<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>
<?php
include ("./include/config.php");
include ("./include/functions.php");
include ("./include/common_start.php");
include ("./include/check_installation.php");
include ("./include/check_admin_login.php");

$page_name = 'datagrid_configurator';

$_SESSION['current_admin_page'] = 'datagrid_configurator.php';

// variables:
// GET
// $table_name
// POST
// 
// $function from this page ("delete_records", "refresh_table",......)

// get the array containing the names of the tables installed
$installed_tables_ar = build_tables_names_array(0, 1, 1);

if (isset($_GET["tablename"])){
	$table_name = $_GET["tablename"];
} // end if
else{
	if (count($installed_tables_ar)>0){
		// get the first table
		$table_name = $installed_tables_ar[0];
		
		// override if there is at least one non admin table
		foreach ($installed_tables_ar as $installed_tables_ar_el){
			if ($installed_tables_ar_el !== $users_table_name && $installed_tables_ar_el !== $groups_table_name && $installed_tables_ar_el !== $prefix_internal_table.'static_pages' ){
				$table_name = $installed_tables_ar_el;
				break;
			}
		}
		
	} // end if
} // end else

if (!in_array($table_name, $installed_tables_ar)){
	header('Location:'.$site_url.'permissions_manager.php');
}

if (isset($_POST["function"])){
	$function = $_POST["function"];
} // end if
elseif (isset($_GET["function"])){
	$function = $_GET["function"];
} // end if
else{
	$function = "";
} // end else

include ("./include/header.php");

$confirmation_message = "";
$error_message = "";
$alert_message = '';

?>

<?php

if (isset($_POST["field_to_change_name"])){
	$field_to_change_name = $_POST["field_to_change_name"];
} // end if
if (isset($_POST["field_to_change_new_position"])){
$field_to_change_new_position = $_POST["field_to_change_new_position"];
} // end if

$confirmation_message = "";

if (isset($table_name)){
	// build the select with all installed table
	$change_table_select = build_change_table_select(0, 1);
	$table_internal_name = $prefix_internal_table.$table_name;
} // end if


switch($function){
	case 'save_template_options':
		
		if (!isset($_POST['enable_template_table'])){
			$enable_template_table = "0";
		} // end if
		else{
			$enable_template_table = $_POST['enable_template_table'];
		}
		
		
		$sql ="update ".$quote.$table_list_name.$quote." set ".$quote."enable_template_table".$quote." = '".$enable_template_table."'";
		
		if (isset($_POST['template_table'])){ // could be not set because the textarea is disabled when I uncheck the checkbox
			$sql .= ", ".$quote."template_table".$quote." = '".$_POST['template_table']."'";
		}
		
		$sql .= " where ".$quote."name_table".$quote." = '".$table_name."'";
		$res_update = execute_db($sql, $conn);
		$confirmation_message .= "Template options correctly saved.";
		
		
		break;
		
	default:
		break;
} // end switch
?>

<span id="confirmation_message_container">
<?php
if ($confirmation_message != ""){
	echo '<div class="msg_ok" id="confirmation_message"><p>'.$confirmation_message.'<br/><br/><a href="javascript:{}" id="confirmation_message_close_link">Ok, close</a></p></div>';
} // end if
if ($error_message != ""){
	echo '<div class="msg_error" id="error_message"><p>'.$error_message.'<br/><br/><a href="javascript:{}" id="error_message_close_link">Ok, close</a></p></div>';
} // end if
if ($alert_message != ""){
	echo '<div class="msg_alert" id="alert_message"><p>'.$alert_message.'<br/><br/><a href="javascript:{}" id="alert_message_close_link">Ok, close</a></p></div>';
} // end if
?>
</span>

<?php if (count($installed_tables_ar)>0){ // otherwise it means that no internal tables are installed

// get the array containg label and other information about the fields
$fields_labels_ar = build_fields_labels_array($table_internal_name, "1"); // because I need it for the display of the select in the form

?>


<p><font size="+1">Configure the datagrid template for the table <b><?php echo $table_name; ?></b></font></p>

<?php
if ($change_table_select != ""){
?>
<form method="get" action="datagrid_configurator.php" name="change_table_form"><input type="hidden" name="function" value="change_table">
<?php echo $change_table_select; ?> Change table
</form>
<?php
}



$only_include_allowed = 0;
$installed_table_infos_ar = build_installed_table_infos_ar($only_include_allowed, 1);

foreach ($installed_table_infos_ar as $installed_table_infos) {
	if ($installed_table_infos['name_table'] === $table_name) {
		$table_alias = $installed_table_infos['alias_table'];
		$enable_template_table = $installed_table_infos['enable_template_table'];
		$template_table = $installed_table_infos['template_table'];
	} // end if
} // end while

?>
<table>



<tr><td><form method="post" action="datagrid_configurator.php?tablename=<?php echo urlencode($table_name); ?>"><input type="hidden" name="function" value="save_template_options">For this table <strong>enable results template</strong> <input type="checkbox" id="enable_template_table_checkbox" name="enable_template_table" value="1"<?php if ($enable_template_table === '1') echo ' checked'; ?>> this allows to show records according to a user-specified HTML template; if results template is disabled (default) a classic tabular datagrid view is used instead.<br/><br/>Results template: (specify here your HTML template) <a href="javascript:show_template_instructions('How to write a template:');"><img src="images/help.png"></a><br/><textarea id="template_table" name="template_table" rows="10" cols="80"><?php echo $template_table; ?></textarea><br/><br/><input class="button_admin" type="submit" value="Save Template options"></form>


 


</td>


</tr></table>


<?php } // end if?>
<?php
// include footer
include ("./include/footer.php");
?>
