<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>
<?php


session_name($dadabik_session_name);
header('Content-Type: text/html; charset=utf-8');
ob_start();

if ($site_path === ''){
	$site_path = get_site_path();
}

ini_set('session.cookie_path', $site_path);

session_start();



if (!isset($_POST)){
	$_POST=$HTTP_POST_VARS;
}
if (!isset($_GET)){
	$_GET=$HTTP_GET_VARS;
}
if (!isset($_FILES)){
	$_FILES=$HTTP_POST_FILES;
}
if (!isset($_SESSION)){
	$_SESSION=$HTTP_SESSION_VARS;
}

if (strlen($serial_number) !== 8 ){
	
	echo '<p><b>[01] Error:</b> $serial_number must be 8 characters long'; 
	exit;
	
}
elseif ($dbms_type !== 'mysql' && $dbms_type !== 'postgres' && $dbms_type !== 'sqlite' ){
	
	echo '<p><b>[01] Error:</b> $dbms_type must be \'mysql\' or \'postgres\' or \'sqlite\' please check your config.php'; 
	exit;
	
}
elseif($host === '' && $dbms_type !== 'sqlite'){
		echo '<p><b>[01] Error:</b> Please specify $host in your config.php';
		exit;
}
elseif($db_name === ''){
		echo '<p><b>[01] Error:</b> Please specify $db_name in your config.php'; 
		exit;
}
elseif($user === '' && $dbms_type !== 'sqlite'){
		echo '<p><b>[01] Error:</b> Please specify $user in your config.php'; 
		exit;
}
elseif($site_path === ''){
		echo '<p><b>[01] Error:</b> Please specify $site_path in your config.php'; 
		exit;
}
elseif($timezone === ''){
		echo '<p><b>[01] Error:</b> Please specify $timezone in your config.php'; 
		exit;
}
elseif($secret_key === '' || is_null($secret_key)){
		echo '<p><b>[01] Error:</b> Please specify $secret_key in your config.php';
		exit; 
}
elseif(strlen_custom($secret_key) < 60){
		echo '<p><b>[01] Error:</b> the length of $secret_key must be at least 60 characters, please check your config.php';
		exit; 
}

elseif($dadabik_session_name === '' || is_null($dadabik_session_name)){
		echo '<p><b>[01] Error:</b> Please specify $dadabik_session_name in your config.php'; 
		exit;
}
elseif(strlen_custom($dadabik_session_name) >= 100 || ctype_alnum($dadabik_session_name) === false ||  preg_match('/[A-Za-z]/', $dadabik_session_name) === 0 || $dadabik_session_name === $secret_key || $dadabik_session_name === 'dadabik'){
		echo '<p><b>[01] Error:</b> the length of $dadabik_session_name must be less than 100 characters, it must contain only letters and numbers (at least one letter) and must be different from $secret_key and diffrent from the word "dadabik", please check your config.php'; 
		exit;
}
else{
	$conn = connect_db($host, $user, $pass, $db_name);
	
	if ($dbms_type === 'mssql' || $dbms_type === 'oci8po' || $dbms_type === 'sqlite' || $dbms_type === 'sqlite2') { // hack for mssql and oracle
		$quote = '';
		$quote_2 = '';
		$autoincrement_word = 'INTEGER PRIMARY KEY AUTOINCREMENT';
		$date_time_word = 'datetime';
	} // end if
	elseif($dbms_type === 'mysql'){
		$autoincrement_word = 'INTEGER PRIMARY KEY NOT NULL AUTO_INCREMENT';
		$date_time_word = 'datetime';
		$quote = '`';
		$quote_2 = '`';
	}
	elseif($dbms_type === 'postgres'){
		$autoincrement_word = 'SERIAL';
		$date_time_word = 'timestamp';
		$quote = '"';
		$quote_2 = '&quote;';
	}

}

function unescape_array($var, $for_magic = 0 ) {
	return is_array($var)? array_map("unescape_array", $var):unescape($var, $for_magic);
}
if (get_magic_quotes_gpc()==1) {

    $_POST = unescape_array($_POST,1);
    $_COOKIE = unescape_array($_COOKIE,1);
    $_GET = unescape_array($_GET,1);
}

function addslashes_array($var) {
	return is_array($var)? array_map("addslashes_array", $var):escape($var);
}


$_POST = addslashes_array($_POST);
$_COOKIE = addslashes_array($_COOKIE);
$_GET = addslashes_array($_GET);



$users_table_name = $prefix_internal_table.'users';
$users_table_id_field = 'id_user';
$users_table_id_group_field = 'id_group';
$users_table_username_field = 'username_user';
$users_table_password_field = 'password_user'; 
$users_table_authentication_type_field = 'authentication_type_user';


$groups_table_name = $prefix_internal_table.'groups';
$groups_table_name_field = 'name_group'; 
$groups_table_id_field = 'id_group';
$id_admin_group = 1;


// tables present in the databse
$table_names_ar = build_tables_names_array(0, 0);

if (count($table_names_ar) == 0){ // no table
	echo "<p><b>[02] Error:</b> your database ".$db_name." is empty. No tables found. Please create some tables to manage before using DaDaBIK.";
	exit;
} // end if

// the var is set in check_login but check_login it's not included by e.g. admin, and it's useful for some functions (e.g. build_tables_names_array) to have it set
$current_user_is_administrator = 0;

if ($mbstring_check === 1 && (!function_exists('mb_strlen') || !function_exists('mb_strpos') || !function_exists('mb_strtolower') || !function_exists('mb_strtoupper') || !function_exists('mb_substr') || !function_exists('mb_send_mail'))){
	echo '<p><b>[09] Error:</b> the PHP mbstring extension is not installed, without this extension, if you have multibyte encoding content, you can get unexpected results such as content corruption. If you want to suppress this message at your own risk, set $mbstring_check to 0 in config.php';
	exit;
}



$field_type_for_date = 'date_picker';



$link_target_generic_file = '_blank';

if ($open_blank_generic_file === 0){
    $link_target_generic_file = '_self';    
}

?>
