<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>
<?php



// this is the configuration file
// to install DaDaBIK you have to specify AT LEAST $serial_number, $dbms_type, $host, $db_name, $user, $pass, $timezone, $secret_key, $dadabik_session_name

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
// required installation parameters: please specify at least the following parameters

// your license serial number, you can find it in the email you received from mail@fastspring.com, containing the download link
// and having a subject like "Your DaDaBIK 7.2 PRO File Download"
// the serial number is 8 characters long
$serial_number = '';

// DBMS type ('mysql' or 'postgres' or 'sqlite')
$dbms_type = 'mysql';

// DBMS server host
$host = ''; // the name or the IP of the host (computer) where the DBMS is running (e.g. '127.0.0.1' if the DBMS is running locally); please try 'localhost' instead of '127.0.0.1' if '127.0.0.1' is not working; some Web Hosting providers can require a full name e.g. mysql.yourdomain.com; for SQLite this parameter is not needed. For mysql and postgres you can also specify the port (if it's not the default one) separated from the host by a ":", e.g. "127.0.0.1:5431" to use the port 5431

// database name
$db_name = ''; // for SQLite not only the name but 1) the full path is also needed (e.g. '/my_databases/music_databases/songs.db') and 2) you need to grant to the Web server write permissions on the database file

// database user
$user = 'root'; // this user must have select, insert, update, delete permissions, create and drop permissions are also needed for installation, upgrade and administration area e.g. 'root'; for SQLite this parameter is not needed
// for better security, you should choose a user who has privileges ONLY on the database used by this application ($db_name parameter)

// database password
$pass = ''; // for sqlite this parameter is not needed

// database schema (only needed for postgres, not needed for mysql and sqlite, if you don't know the schema, leave "plublic")
$db_schema = 'public';

// timezone, specify here your timezone (a list of available timezone here: http://php.net/manual/en/timezones.php)
$timezone = 'Europe/Rome';

if ( (double)phpversion() >= 5.1){
	date_default_timezone_set($timezone);
}


// secret_key: a long (60+ characters), random and complicated phrase which is used to sign authentication cookies for this application and therefore improve authentication security; you don't need to remember this phrase
// please note that in order to benefit from this security mechanism you must choose a different secret_key for each DaDaBIK application you create and you must keep this value secret
$secret_key = '';


// dadabik_session_name: the name of the session for this DaDaBIK application, used to avoid unexpected and risky effects if other applications installed in the same domain make use of the same session variable names that this application uses
// it must contain only ASCII letters and numbers, with at least one letter and no blank spaces; its length must be less than 100 characters and must be different than $secret_key; you don't need to remember this name
// please note that in order to benefit from this security mechanism you must choose a name which is unique among session names used by other applications installed in the same domain
$dadabik_session_name = '';




// DaDaBIK complete url (e.g. http://www.mysite.com/john/dadabik/, REMEMBER the trailing slash)
// YOU CAN SAFELY LEAVE THIS PARAMETER EMPTY (''), SET IT ONLY IF DADABIK REDIRECTS YOU TO THE WRONG URL AFTER LOGIN
$site_url = '';


// DaDaBIK site path is the path your session cookies are valid for
// YOU CAN LEAVE THIS OPTION EMPTY (''), NORMALLY IT IS CORRECTLY GUESSED BY DADABIK
// If you want extra security, you can set it manually: if you execute DaDaBIK from e.g. http://www.mysite.com/john/dadabik/ the site path must be /john/dadabik/, remember to put slashes at the beginning and at the end; put just one slash '/' if DaDaBIK is installed in the root of a Website, (e.g. http://www.mysite.com/)

$site_path = '';


// chosose your graphic theme: 'classic', 'black', 'blue' or 'green'
$graphic_theme = 'classic';

// chosose your results grid layout scrolling: 'site_overflow', 'grid_overflow' or 'grid_scroll'
// this affect the layout when your results grid is wider than your screen:
// grid_scroll (default): an horizontal scrollbar appears just for the grid, the grid is independent
// site_overflow (old 7.x DaDaBIK style): an horizontal scrollbar appears for the whole page, all the site layout is affected
// grid_overflow: an horizontal scrollbar appears for the whole page, the site layout is not affected, the grid is independent
// Internet Explorer always works in grid_scroll mode, regardless of the settings.
// Small devices (display width < 768px, typycally smartphones) always work in grid_scroll mode as well
$grid_layout_scrolling = 'grid_scroll';

// choose the type of menu you want to use for page selection: 'left_side_menu' or 'drop_down_menu'
$menu_type = 'left_side_menu';

// display mode for the results grid ('both','classic_grid','list'), the default is 'both', which allows the user to choose through a drop-down menu, 'classic_grid' and 'list' don't show the drop-down menu.
$results_display_mode_menu = 'both';

// additional installation parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////



// prefix to use for the name of the tables created by DaDaBIK, all the tables created by DaDaBIK use this prefix
$prefix_internal_table = 'dadabik_'; // you can safety leave this option as is, you *must* leave this option as is after the installation


/*
DaDaBIK, during the installation, install in the application all the tables available in the database; add here the tables (if any) you want to exclude, one per line, for example if you want to exclude the tables "customers" and "countries" write:
$tables_to_exclude[0]='customers';
$tables_to_exclude[1]='countries';
don't touch this parameter if you want to include all the tables. You can always uninstall tables later using teh admin interface.
*/

$tables_to_exclude[0]='';

/*
DaDaBIK, during the installation, install in the application all the tables available in the database; add here the tables (if any) you want to exclude, one prefix per line, for example if you want to exclude all the tables that start with "wp_" and all the tables that start with "test_" write:
$prefixes_to_exclude[0]='wp_';
$prefixes_to_exclude[1]='test_';

don't touch this parameter if you want to include all the tables. You can always uninstall tables later using teh admin interface.

This parameter, in particular, is often used to easily install and use two or more different DaDaBIK applications using a shared database: for each apppplication you need a different $prefix_internal_table and you need to set, for $prefixes_to_exclude, all the prefixes used by the other applications.

*/
 
$prefixes_to_exclude[0]='';


// language parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// the list of languages the user can choose from; you can remove one or more languages or change the position. If you leave just one language, the change language listbox will not be displayed.
// the list of languages available is: 'english', 'italian', 'german', 'dutch', 'spanish', 'french', 'portuguese', 'croatian', 'polish', 'catalan', 'estonian', 'rumanian', 'hungarian','norwegian', 'slovak', 'swedish', 'russian', 'danish', 'finnish', 'czech','telugu'

$languages_ar = array ('english','italian','catalan','chinese','croatian','czech','danish','dutch','estonian','finnish','french','german','hungarian','norwegian','polish','portuguese','rumanian','russian','slovak','spanish','swedish','telugu');

// authentication and security parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// enable the users authentication (0|1). If you set 1, you have to login to use DaDaBIK
// by default DaDaBIK create an administrator user (username: root password: letizia) and a normal user (username: alfonso password: letizia); for security reasons please change both the passwords as soon as possible and never publish a DaDaBIK application having the default passwords
// if you disable the authentication and the "export to CSV" feature is enabled (see $export_to_csv_feature later), please consider that search engine robots, accessing the CSV export link, could consume an inordinate amount of processor time.
$enable_authentication = 1;

// enable user password modification (0|1). If you set 1, users can change their own password.
$enable_user_password_modification = 1;

// number of times a user can type the wrong password before the account is blocked
// the failed login counter, before reaching maximum allowed number, is reset to 0 when the user correctly access the application using the right password (even from another IP/computer)
// If a user access a DaDaBIK application through a Wordpress authentication, this limit has no effect
// An admin user can re-enable a blocked user from the "edit" page of the user
$number_failed_login_before_blocking = 10;

// enable the Wordpress authentication (0|1). If DaDaBIK is integrated into a Wordpress website and $wordpress_authentication is 1, users authenticated through Wordpress are automatically authenticated into DaDaBIK too, without doing the log-in again. The Wordpress authentication feature requires that the DaDABIK application is installed in a subdirectory of the Wordpress site and that the same users (same username) is available both in Wordpress and DaDaBIK.
// please note that if $wordpress_authentication = 1, two users having the same username (one on Wordpress and one on DaDaBIK) can coexist and both access DaDaBIK as they were the same user, even if they have two different passwords
// please note that the Wordpress and DaDaBIK session expirations are not synchronized: if your session expires in Wordpress it doesn't mean it automatically expires in DaDaBIK. Use the logout button in Wordpress to be sure to disconnect to both Wordpress and DaDaBIK.
// If you enable the Wordpress authentication, you should login/logout through Wordpress without using DaDaBIK login/lougout; mixing Wordpress and DaDaBIK login/logout can lead to unexpected behaviours.
$wordpress_authentication = 0;

// enable granular permissions (0|1). Granular permissions allow you to set, for each users group, which operations (read, delete, update, create, details, search and quick search) are allowed on each form and field.
$enable_granular_permissions = 1;

// leave FALSE for better security in passowrd storage, change to TRUE for maximum application portability on old systems (see http://www.openwall.com/phpass/ for further details)
$generate_portable_password_hash = FALSE;

// grant permissions after tables installation (0|1|2). By default, when you install a new table in DaDaBIK, all the related permissions are set to NO, leave 0 here if you want to keep this behaviour, 1 if you want to automatically set all the permissions to YES, 2 if you want to autmatically set all the permissions to YES only for the administrator group. If you are not using granular permissions, options 1 and 2 produce the same effect.
$grant_permissions_after_table_installation = 0;

// grant permissions to autoincrement fields after table installations. By default, DaDaBIK treats autoincremnt fields as normal fields, set to 0 if you don't want to grant permissions to autoincremnt fields. This is often useful because normally you don't want to see "ID" fields in your forms, especially in the insert forms (you want the value to be automatically generated and assigned). Of course you can alwasy remove the permissions (and hide a field from a form) later.
// this parameter is currently considered only with MySQL, with other DBMSs the autoincremnt fields are always treated as normal fields.
$grant_permissions_autoincrement_after_table_installation = 1;




// Use the id_group of the user, instead of the username, to fill ID_user fields (0|1)
// this also affects how the owner permissions work (id_group instead of username will be used to control read, delete, update)
// please note that if you change this parameter for a running application that uses one or more ID_user field types, you will end up in an inconsistent situation where some records have the username of the user as oweer and some others the id_group
$use_id_group_for_ownership = 0;

// Enable create view (0|1): set to 1 to enable database views creation from DaDaBIK (admin interface -> Pages). Please note that when $enable_crate_view is set to 1, from admin -> Pages it is possible to create views incluing all the data the database user set for this application has privileges on, even data coming from other databases than the one is set in $db_name.
$enable_create_view = 0;

// By default, the use of semicolon characters is not allowed for the SQL query you use to create a VIEW in the admin -> pages section. It's a security measure, if an attacker gets access to the admin section, the semicolon can be exploited to add malicious queries to the "create view" query (e.g. insert, delete, drop queries on all the data the database user set for this application has privileges on).
// You can enable semicolons by setting this parameter to 1
$enable_semicolon_create_view = 0;

// By default, the use of semicolon characters is not allowed for the custom SQL query you use to create a report. It's a security measure, the semicolon can be exploited to add malicious queries to the "SELECT" query (e.g. insert, delete, drop queries on all the data the database user set for this application has privileges on).
// You can enable semicolons by setting this parameter to 1
$enable_semicolon_sql_report = 0;

// show the box containing the logout, edit your account and admin link (right top corner) (0|1)
// normally you want to set to 0 only if your DaDaBIK application is embedded in a Wordpress applicaiton and you enabled Wordpress authentication
$show_logout_account_admin_box = 1;





// deletion parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// enable delete all feature (delete operations must be enabled too, from the administration interface) (0|1)
$enable_delete_all_feature = 1;

// when a record is deleted, delete also the uploaded files related to that record (0|1)
$delete_files_when_delete_record = 1;

// ask confirmation before deleting a record? (0|1); note that this works just for the standard data grid, not for template data grids
$ask_confirmation_delete = 1;

// CSV parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// enable export to CSV for excel feature (0|1)
$export_to_csv_feature = 1;

// CSV separator
// If you want to directly open the CSV files with MS Excel, you have to use ; instead of ,
$csv_separator = ",";

// CSV file creation time limit (in seconds), in order to use it uncomment the line below by removing // and set the number of seconds. This feature makes use of the set_time_limit() function and has no effect when PHP is running in safe mode
//$csv_creation_time_limt = 30;

// null handling parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// set to 1 if you want to:
// 1) Treat empty form fields as NULL values during insert and update
// 2) View NULL values as empty form fields during edit
// $treat_blank_as_null = 1 should be the most user friendly option if your DaDaBIK application is used by non-technical users.
$treat_blank_as_null = 0;

// the word used to display a NULL content (could also be a blank string '', it is always a blank string in edit/insert forms if $treat_blank_as_null is 1)
$null_word = '';

// if $treat_blank_as_null is 0, for each field a NULL checkbox is displayed and allows to set the NULL value during insert/edit, unless you set $null_checkbox to 0. If you set $null_checkbox to 0 and $treat_blank_as_null to 0 there is no way to insert a NULL value as a field value of a record
// note that, if the record you are editing contains a NULL value for one or more fields, the NULL checboxes are displayed anyway, even if $null_checkbox is set to 0 (unless you have set treat_blank_as_null to 1)
$null_checkbox = 0;

// Upload parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// relative URL from the DaDaBIK root dir to the upload folder; you can leave the default one, remember to put a slash (/) at the end if you change it
$upload_relative_url = 'uploads/';

// absolute path of the upload dir - please put slash (/) at the end
// e.g. 'c:\\data\\web\\dadabik\\uploads\\' on windows systems
// e.g. '/home/my/path/dadabik/uploads/' on unix systems
// make sure the webserver can write in this folder and in the temporary upload folder used by PHP (see php.ini for details)
// SECURITY: You SHOULD PROTECT the upload directory from public access, otherwise anyone who knows the URL of a file you have uploaded via DaDaBIK can access the file itself, even without logging-in. By default, STARTING FROM DADABIK 6.3 the /uploads folder contains an .htaccess file which should prevent public access on Apache, please test it because it might not work in your environment; if you change the default upload directory or use a different Web server than Apache you should provide the needed security by yourself. If you are upgrading from a version prior to 6.3 you probably DON'T have the .htaccess file. Please note that, depending on your computer / FTP configuration it is possible that you can't see the .htacces file, because it starts with a dot (.).
$upload_directory = '';

// max allowed size for the uploaded files (in bytes)
$max_upload_file_size = 20000000;

// allowed file extensions (users will be able to upload only files having these extensions); you can add new extensions and/or delete the default ones; if you add extensions you also have to provide the correct MIME type adding an element to the array $allowed_file_exts_mime_ar, if you delete an extension you have to delete also the corresponding MIME type in the $allowed_file_exts_mime_ar array

$allowed_file_exts_ar[0] = 'jpg';
$allowed_file_exts_ar[1] = 'gif';
$allowed_file_exts_ar[2] = 'tif';
$allowed_file_exts_ar[3] = 'tiff';
$allowed_file_exts_ar[4] = 'png';
$allowed_file_exts_ar[5] = 'txt';
$allowed_file_exts_ar[6] = 'rtf';
$allowed_file_exts_ar[7] = 'doc';
$allowed_file_exts_ar[8] = 'xls';
$allowed_file_exts_ar[9] = 'htm';
$allowed_file_exts_ar[10] = 'html';
$allowed_file_exts_ar[11] = 'csv';
$allowed_file_exts_ar[12] = 'pdf';

$allowed_file_exts_mime_ar[0] = 'image/jpg';
$allowed_file_exts_mime_ar[1] = 'image/gif';
$allowed_file_exts_mime_ar[2] = 'image/tiff';
$allowed_file_exts_mime_ar[3] = 'image/tiff';
$allowed_file_exts_mime_ar[4] = 'image/png';
$allowed_file_exts_mime_ar[5] = 'text/plain';
$allowed_file_exts_mime_ar[6] = 'application/rtf';
$allowed_file_exts_mime_ar[7] = 'application/msword';
$allowed_file_exts_mime_ar[8] = 'application/vnd.ms-excel';
$allowed_file_exts_mime_ar[9] = 'text/html';
$allowed_file_exts_mime_ar[10] = 'text/html';
$allowed_file_exts_mime_ar[11] = 'text/plain';
$allowed_file_exts_mime_ar[12] = 'application/pdf';

$allowed_all_files = 0; // set to 1 if you want to allow all extensions, and files without extension too; please note that, since you cannot provide the MIME type for all possibile files, file having extensions different than the ones specifiy in $allowed_file_exts_ar are not guaranteed to be handled as expected

// for generic files, when you click on the link to open the file itself, the file is open in a new window (_blank); set this parameter to 0 if you want to open it in the same window (_self)
$open_blank_generic_file = 1;

// Uploded pictures, thumbnail parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

/*
If you don't want to use thumbnails, you can leave 0 for all the four parameters and the browser will display the uploaded images at their original size.
If you set a max width or height, the browser will resize the picture according to that. You can also force just width or just height, the browser will always scale the other dimension proportionally. 
*/

// maximum width (in px) of the pictures displayed in the results grid
$picture_thumbnail_results_grid_max_width = 0;

// maximum height (in px) of the pictures displayed in the results grid
$picture_thumbnail_results_grid_max_height = 0;

// maximum width (in px) of the pictures displayed in the details page
$picture_thumbnail_details_max_width = 0;

// maximum height (in px) of the pictures displayed in the details page
$picture_thumbnail_details_max_height = 0;

// Duplication check parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// maximum number of records to be displayed as duplicated during insert
$number_duplicated_records = 30;

// select similarity percentage used by duplication insert check
$percentage_similarity = 80;

// debug parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// display the main sql statements of insert/search/edit/detail operations for debugging (0|1)
// note that the insert sql statement is will be displayed only if $insert_again_after_insert is set to 1 and $show_details_after_insert = 0
$display_sql = 0;

// display all the sql statements and the MySQL error messages in case of DB error for debugging (0|1)
$debug_mode = 0;

// display the "I think that x is similar to y......" statements during duplication check (0|1)
$display_is_similar = 0;

// search parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// enable the quick search feature, which provides a quick search row at the top of the results
$enable_quick_search_feature = 1;

// allow the "and/or" choice directly in the form during the search (0|1)
$select_operator_feature = 1;

// default operator (or/and), if the previous is set to 0
$default_operator = 'and';

// enable the possibility, for users, to specify AND / OR operators during a search e.g. typing "apple OR banana" (0|1)
// operators are case sensitive, OR and AND must be written in capital letters
// users cannot mix operators (city AND Europe OR USA)
$enable_user_booleans = 0;

// default order type: results grid, default order type (ascendant or descendant) to use ('ASC'|'DESC')
$default_order_type = 'ASC';

// data grid and details page parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// items of the menu used to choose the number of result records displayed per page, you can add new numbers and/or delete the default ones, don't delete $records_per_page_ar[0]
$records_per_page_ar[0] = 10;
$records_per_page_ar[1] = 20;
$records_per_page_ar[2] = 50;
$records_per_page_ar[3] = 100;

// target window for details/edit, 'self' is the same window, 'blank' a new window; this works just for the standard data grid, not for template data grids
$edit_target_window = 'self';

// coloumn at which a text, textarea and select_single field will be wrapped in the results page, this value also determines the width of the coloumn in the results table (standard data grid) if $word_wrap_fix_width is 1
$word_wrap_col = '25';

// allow that $word_wrap_col value also determines the width of the coloumn in the results table (standard data grid) (0|1)
$word_wrap_fix_width = 0;

// always wrap words at the $word_wrap_col column, even if it is necessary to cut them (0|1)
// FEATURE NO LONGER AVAILABLE!
$enable_word_wrap_cut = 1;

// image files to use as icons for delete, edit, details
// you can use both relative or absoulute url here
$delete_icon = 'images/delete.png';
$edit_icon = 'images/edit.png';
$details_icon = 'images/details.png';

// enable results table row highlighting (0|1)
$enable_row_highlighting = 1;

// separator to use while displaying several lookup table linked field values related to the same field (in data grid and details page)
// e.g. Let's say if you have an id_customer select_single field having as linked lookup table linked fields first_name_customer and last_name_customer, the value ' - ' for $separator_display_linked_field will make an id_customer field value to be displayed as, e.g. "john - smith"
$separator_display_linked_field = ' '; // if you need more than one subsequent blank space, use the &nbsp; html entity for each one

// separator to use while displaying several values related to the same select_multiple_* field (in data grid and details page)
$separator_display_select_multiple = '<br/>';

// foor lookup field, you can choose in form configurator if you want to show a link to the related linked record; the parameter $function_link_to_record allows to choose which page you want to open when the link is clicked ('details' or 'edit')
$function_link_to_record = 'details';

// report parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// enable report generation (0|1)
$enable_report_generation = 1;

// enable advanced SQL reports (0|1); if you enable advanced SQL reports, users will be able to define the report using a custom SQL SELECT query. Please note that ANY SELECT query is allowed, regardless of the permissions you set in DaDaBIK -> Admin Area, so the user might have access to any data in your database or even in other databases, if database user used by this DaDaBIK application ($user, look at the beginning of the file) has the needed permissions 
$enable_advanced_sql_report = 0;

// The list of operators you can use to aggregate data when you generate a report; if you don't need one or more operator, simply comment the line adding // at the beginning of the row
$group_by_operators[0]='percentage';
$group_by_operators[1]='count';
$group_by_operators[2]='sum';
$group_by_operators[3]='average';
$group_by_operators[4]='min';
$group_by_operators[5]='max';
$group_by_operators[6]='variance';
$group_by_operators[7]='standard_deviation';

// The list of DaDaBIK field types you can use for "group by" and for aggregate functions when you generate reports; if you want to disable one or more field types, simply comment the line adding // at the beginning of the row, if you want to add a field type, add a new line. Please note that select_multiple field types don't work correctly here, don't add them.
$available_report_field_types[0]='text';
$available_report_field_types[1]='select_single_radio';
$available_report_field_types[2]='select_single';
$available_report_field_types[3]='date';
$available_report_field_types[4]='date_time';
$available_report_field_types[5]='insert_date_time';
$available_report_field_types[6]='update_date_time';
$available_report_field_types[7]='ID_user';

// The list of date functions you can use when, during the production of a report, you aggreagate your data based on a date or datetime field; if you want to disable one or more functions, simply comment the line adding // at the beginning of the row, you can't add additional functions
$report_date_functions[0]='';
$report_date_functions[1]='month';
$report_date_functions[2]='year';
$report_date_functions[3]='quarter';
$report_date_functions[4]='week';
$report_date_functions[5]='dayofweek';
$report_date_functions[6]='hour';

// weekdays standard, set weeks_start_with_sunday to 1 if you want weeks to start on Sunday, otherwise weeks start on Monday
$weeks_start_on_sunday = 0;

// dates parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// field type for date and date time ('classic' or 'date_picker')
// the 'classic' method uses list boxes (one list box for year, one for month, ....); the 'date_picker" method uses a normal textbox plus a date/time picker

// WARNING: CLASSIC is not available anymore, even if you choose it date_picker will be used instead.
$field_type_for_date = 'date_picker';

// format used to display date fields ('literal_english', 'latin' or 'numeric_english')
// 'literal_english': May 31, 2010
// 'latin': 31-5-2010
// 'numeric_english': 5-31-2010
// please note that, in edit mode, the date in a date picker is always displayed in year-month-day format
// note that, depending on your system, you can have problem displaying dates prior to 01-01-1970 or after 19-01-2038 if you use the literal english format; in particular, it is known that this problem affects windows systems
$date_format = 'numeric_english';

// date field separator (divides day, month and year; used only with latin and numeric_english date format)
$date_separator = "-";

// years range for the date picker, by default it's 20 years (-10 +10 respect to the current year) you can also set a specific year e.g. $start_year = 1960
$start_year = date('Y')-10;
$end_year = date('Y')+10;



// insertion parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// choose if, after an insert, you want DaDaBIK to display again the insert form (1) or not (0)
$insert_again_after_insert = 0;

// choose if, after an insert, you want DaDaBIK to show you a details page of the record just inserted
$show_details_after_insert = 0;

// record locking parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// enable the record lock feature when a user is editing a record
$enable_record_lock_feature = 1;

// number of seconds after which a record is automatic unlocked (useful to avoid a record being locked forever when, for example, a user enters the record in edit mode and then left his workstation); choose a value >= 60
$seconds_after_automatic_unlock = 240;

// forms settings
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// show update and search submit buttons also at the top of the forms, not just at the bottom (0|1)
$show_top_buttons = 0;

// in the edit form show, after SAVE and BACK buttons, a SAVE+BACK button
$show_save_plus_back_button = 1;

// number of items a select_multiple_menu field should show
$size_multiple_select = 3;

// show "previous" and "next" buttons in edit and details forms (0|1)
// if you have tables with millions of records and your memory is not enough, the Web server could crash trying to find the next/previous record; if this happens, you should disable $show_previous_next
$show_previous_next = 1;

// menu settings
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// always show menu items; by default they are hidden if they are not at TOP level AND they (and their parents) are not currently selected) (0|1)
$always_show_menu_itmes = 0;

// email notices parameters
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// enable_insert_notice_email_sending: when a new record is inserted an e-mail containing the record details will be sent to the addresses below (0|1)
// this feature requires an "auto increment" primary key in the relative table
$enable_insert_notice_email_sending = 0;

// set here the recipient addresses of the insert notice e-mail
// Here is an example
// $insert_notice_email_to_recipients_ar[0] = 'my_account_1@my_provider.com';
// $insert_notice_email_to_recipients_ar[1] = 'my_account_2@my_provider.com';
// $insert_notice_email_cc_recipients_ar[0] = 'my_account_3@my_provider.com';
// $insert_notice_email_bcc_recipients_ar[0] = 'my_account_4@my_provider.com';

$insert_notice_email_to_recipients_ar[0] = '';

$insert_notice_email_cc_recipients_ar[0] = '';

// please note that on some PHP versions, probably only on MS Windows, the mail() function doesn't work fine: the messages are not send to the bcc addresses and the bcc addresses are shown in clear!!!
$insert_notice_email_bcc_recipients_ar[0] = '';

// enable_update_notice_email_sending: when a record is updated an e-mail containing the new record details will be sent to the addresses below (0|1)
$enable_update_notice_email_sending = 0;

// set here the recipient addresses of the update notice e-mail
// Here is an example
// $update_notice_email_to_recipients_ar[0] = 'my_account_1@my_provider.com';
// $update_notice_email_to_recipients_ar[1] = 'my_account_2@my_provider.com';
// $update_notice_email_cc_recipients_ar[0] = 'my_account_3@my_provider.com';
// $update_notice_email_bcc_recipients_ar[0] = 'my_account_4@my_provider.com';

$update_notice_email_to_recipients_ar[0] = '';

$update_notice_email_cc_recipients_ar[0] = '';

// please note that on some PHP versions, probably only on MS Windows, the mail() function doesn't work fine: the messages are not send to the bcc addresses and the bcc addresses are shown in clear!!!
$update_notice_email_bcc_recipients_ar[0] = '';

// other parameters
///////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////// 


// $open_url_field_type_new_window (0|1); by default, for URL field type, the link is open in the current page (target _self), set this parameter to 1 if you prefer to open a new window (_blank)
$open_url_field_type_new_window = 0;


// settings related to the auto-configurator feature
/*
DaDaBIK, using some rules, tries to guess the field types, labels field content types and other paramters you would set for a DaDaBIK application after its installation. The guess works according to some "signals"; for example, if a database field name contains the word "email", DaDaBIK set the content type of the field as email.
You can influence the rules used by DaDaBIK changing the following parameters. You can safety leave the the settings as they are if you want to use the default rules
*/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// enable the auto-configurator feature (0|1)
$enable_auto_configurator = 1;

// set the NOT NULL database fields as required in DaDaBIK update/insert forms (0|1)
$autoconf['set_notnull_fields_as_required'] = 1;

// set the correspondence between database field types and DaDaBIK field type/content

// settings for MySQL
// DB field types that dadabik considers as numeric
$autoconf['numeric_fields']['mysql'] = array('integer','int','smallint','tinyint','mediumint','bigint','decimal','numeric','float','double','bit','year');

// DB field types that dadabik considers as date
$autoconf['date_fields']['mysql'] = array('date');

// DB field types that dadabik considers as date_time
$autoconf['date_time_fields']['mysql'] = array('datetime','timestamp');

// DB field types that dadabik considers as textbox 
$autoconf['textbox_fields']['mysql'] = array('char','varchar','binary','varbinary');

// DB field types that dadabik considers as textarea 
$autoconf['textarea_fields']['mysql'] = array('blob','text');

// DB field types that dadabik considers as select_single 
$autoconf['select_single_fields']['mysql'] = array('enum');

// settings for PostgreSQL
// feature not available for PostgreSQL
$autoconf['numeric_fields']['postgres'] = array('bigint','int8','bigserial','serial8','bit','bit varying','varbit','double precision','integer','int','int4','float8','numeric','decimal','real','float4','smallint','int2','serial','serial4');



// DB field types that dadabik considers as date
$autoconf['date_fields']['postgres'] = array('date');

// DB field types that dadabik considers as date_time
$autoconf['date_time_fields']['postgres'] = array('timestamp','timestamp with time zone','timestamp without time zone');

// DB field types that dadabik considers as textbox 
$autoconf['textbox_fields']['postgres'] = array('character varying','character','varchar','char');

// DB field types that dadabik considers as textarea 
$autoconf['textarea_fields']['postgres'] = array('text');

// DB field types that dadabik considers as select_single 
$autoconf['select_single_fields']['postgres'] = array();

	

// settings for SQLite
// feature not available for SQLite
$autoconf['numeric_fields']['sqlite'] = array('int','integer','tinyint','smallint','mediumint','bigint','unsigned big int','int2','int8','real','double','double precision','float','numeric','decimal'.'boolean');

// DB field types that dadabik considers as date
$autoconf['date_fields']['sqlite'] = array('date');

// DB field types that dadabik considers as date_time
$autoconf['date_time_fields']['sqlite'] = array('datetime');

// DB field types that dadabik considers as textbox 
$autoconf['textbox_fields']['sqlite'] = array('character','varchar','varying character','nchar','native character','nvarchar');

// DB field types that dadabik considers as textarea 
$autoconf['textarea_fields']['sqlite'] = array('text','clob','blob');

// DB field types that dadabik considers as select_single 
$autoconf['select_single_fields']['sqlite'] = array();


// set the correspondence between the name of the database field and the DaDaBIK content

// words that DaDaBIK considers as a hint to guess the content of the field is phone
$autoconf['phone_words'] = array ('phone', 'telefono');

// words that DaDaBIK considers as a hint to guess the content of the field is email
$autoconf['email_words'] = array ('email');

// words that DaDaBIK considers as a hint to guess the content of the field is url
$autoconf['url_words'] = array ();



$autoconf['numeric_fields']['search_operators'] = 'is_equal/is_different/greater_than/less_then/is_null/is_not_null';
$autoconf['date_fields']['search_operators'] = 'is_equal/is_different/greater_than/less_then/is_null/is_not_null';
$autoconf['date_time_fields']['search_operators'] = 'is_equal/is_different/greater_than/less_then/is_null/is_not_null';
$autoconf['textbox_fields']['search_operators'] = 'contains/is_equal/is_different/starts_with/ends_with/greater_than/less_then/is_null/is_not_null/is_empty/is_not_empty';
$autoconf['textarea_fields']['search_operators'] = 'contains/is_equal/is_different/starts_with/ends_with/greater_than/less_then/is_null/is_not_null/is_empty/is_not_empty';
$autoconf['select_single_fields']['search_operators'] = 'is_equal/is_different/is_null/is_not_null';


// default settings: when DaDaBIK doesn't see any particular signal to guess a field configuration, it ueses these default values

// field type
$autoconf['default']['type_field'] = 'text';

// field content type
$autoconf['default']['content_field'] = 'alphanumeric'; 

// Maxlength
$autoconf['default']['maxlength_field'] = '100';

// Search operators
$autoconf['default']['search_operators'] = 'is_equal/is_different/contains/starts_with/ends_with/greater_than/less_then/is_null/is_not_null/is_empty/is_not_empty';

// Is the field required in DaDaBIK insert/edit forms? ('0'|'1')
$autoconf['default']['required_field'] = '0';

// advanced configuration settings, you can safety leave the following settings as they are
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

// the name of the main file of DaDaBIK, you can safety leave this option as is unless you need to rename index.php to something else
$dadabik_main_file = 'index.php';

// the name of the login page of DaDaBIK, you can safety leave this option as is unless you need to rename login.php to something else
$dadabik_login_file = 'login.php';

// function to apply to all textbox values inserted by the user, before INSERT and UPDATE occur (e.g. you may want to capitalize values)
// leave empty if no function is needed (in fact, normally is NOT needed) or fill the parameter with the function's name (the name   must start with "dadabik_") and write the related function's code in custom_functions.php. In custom_functions.php you can find an example (function dadabik_capitalize)
$function_user_values = '';

// prefix of the NULL checkbox name
$null_checkbox_prefix = 'null_value__';

// suffix of the select type (contains, is_null....) listbox
$select_type_select_suffix = '__select_type';

// suffix of the date time types
$year_field_suffix = '__year';
$month_field_suffix = '__month';
$day_field_suffix = '__day';
$hours_field_suffix = '__hours';
$minutes_field_suffix = '__minutes';
$seconds_field_suffix = '_seconds';

// htmLawed configuration, you shouldn't change this parameter, changing this parameter can lead to security problems, read documentation for more information
$htmlawed_config = array('safe'=>1, 'deny_attribute'=>'style, class');

// choose the correct db library; you shouldn't change this parameter
$db_library = 'pdo';

// perform a check about mbstring extension installation; this parameter should be always set to 1
$mbstring_check = 1;

// alias_prefix
$alias_prefix = '__'; // you can safety leave this option as is

// table_list_name name
$table_list_name = $prefix_internal_table."table_list"; // this parameter is here for historical reasons, don't change it

// how does DaDaBIK read the files uploaded: 'public_url' or 'php'; for security reason, you should keep this option set to "php" and keep the upload folder (see $upload_directory) protected from public access (see documentation)
$file_access_mode = 'php';

// The separator characther used in form configurator to separate values in  "option to include", "Linked fields", "Linked items table names" and "Items table foreign key field names" parameters. If you change this parameter after the installation, you will have to modify the charaters whereever you used it in the form configurator
// the lenght of the separator needs to be 1
define('FORM_CONFIGURATOR_SEPARATOR', '~');


// if 1, the custom formatting functions take in input, for select_single/select_multiple fields having more than one linked field, each linked field value singularly. This allows to have more control on the outupt. It should be set to 0 just for compatibility with DaDaBIK applications created with DaDaBIK < 7.1 (if you can't modify your formatting functions). (0|1)
$pass_linked_fields_to_format_function_as_array = 1;

// default function to be executed when you click on a menu item related to a page based on table/view. If you don't specify anything, by default the results grid is shown; alternatively, you can add an elmeent to the associative array $table_default_functions and specify 'show_search_form' or 'show_insert_form'
/* in this example
$table_default_functions['customers'] = 'show_insert_form';
for the table customers, the default function is show_insert_form
*/

// minimum number of characters to type in a user-friendly searchable ajax drop-down menu before DaDaBIK starts querying the table to find the matching options
$ajax_dropdown_minimum_input_length = 3;



?>
