<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>
<?php


// CALCULATED FIELDS FUNCTIONS

/*
Calculated field function template

Each calculated field function receives in input an associative array $parameters containing all the values coming from the INSERT / UPDATE form.
Each calculated field function must return the value to assign to the calculated field and it is automatically executed every time an insert or update operation is executed and every time one of the input value is modified in the INSERT / UPDATE form.

In this simple example (dadabik_calculate_total_price_product) we have a field total_price_product whose value is calculated as the sum of price_product + tax_product.

Please note that we check if the input values are NULL or empty ( '' ) before performing the addition. This is particularly useful in the insert form: when you open an insert form, total_price_product is immediately calculated according to the values of price_product and tax_product you have in the form, but if you have just opened the insert form, they would be empty.

Using as input a field from the form that is also a calculated field can lead to unexpected results.

*/

/*
function dadabik_calculate_total_price_product($parameters_ar){
	
	if ( $parameters_ar['price_product'] !== '' && !is_null($parameters_ar['price_product']) && $parameters_ar['tax_product'] !== '' && !is_null($parameters_ar['tax_product'])){
		return ($parameters_ar['price_product'] + $parameters_ar['tax_product']);
	}
	else{
		return NULL;
	}
	
}
*/


// CUSTOM VALIDATION FUNCTIONS

// custom validation function template
// each custom validation function receives in input an array $parameters containing all the values coming from the form posted, including the fields values
// each custom validation function must return the boolean true or the boolean false.
// in this simple exeample we just check if the field quantity_product value is between 0 and 30
// you also have to specify the error message in your language file (see /include/languages), using as a key nameofthefunction_not_valid; in this example, you would add a sentence to the $normal_messages_ar array having key = dadabik_validate_quantity_product_not_valid 
// why you have in inputs all the $_POST values? Because the validation rule of a field could depend on the value of the others
// please note that only NOT NULL and NOT empty field values are validated, if you are looking for a method to check requiredness, you can simply set a field as required in the form configurator.   
// please also note that if you need to use a field value, the correspondent field cannot be disabled in the edit form

/*
function dadabik_validate_quantity_product($parameters_ar){
	
	
	if ($parameters_ar['quantity_product'] >= 0 && $parameters_ar['quantity_product'] <= 30){
		return true;
	}
	else{
		return false;
	}
	
}
*/


// CUSTOM FORMATTING FUNCTIONS

// custom formatting function template
// each custom formatting function receives in input the value to display $value
// each custom validation function must return the formatted value
// in this simple exeample we just format the field last_name_customer to be displayed in red
// if the value is a select_single/select_multiple fields having more than one linked fields, $value is an array, where $value[0] is the value of the first linked field, $value[1] the value of the second and so on 
/*
function dadabik_format_last_name_customer($value){

	return '<span style="color:red">'.$value.'</span>';
	
	
}
*/

// custom required functions

// custom required function template
// each custom required function receives in input an array $parameters containing all the values coming from the form posted, including the fields values
// each custom required function must return the boolean true or the boolean false.
// in this simple exeample, we have created a function for the field "state", which is reuired only if the country is "USA"
// why you have in inputs all the $_POST values? Because the validation rule of a field could depend on the value of the others
// please note that if you need to use a field value, the correspondent field cannot be disabled in the edit form
/*
function dadabik_required_state_customer($parameters_ar){
	
	
	if ($parameters_ar['country_customer'] === 'USA'){
		return true;
	}
	else{
		return false;
	}
	
}
*/

// HOOKS (ONLY WORK WITH DaDaBIK Enterprise)
/*

A DaDaBIK hook is a feature that allows you to write some PHP code to be called under certain circumstances.
DaDaBIK currently supports after insert, after update, after delete, before update and before delete hooks. In the example below we define an after insert hook on the table accounts, setting the custom function that DaDaBIK has to execute: dadabik_send_notice_after_accounts_insert.
We then write the actual code of the function dadabik_send_notice_after_accounts_insert, that retrieves the name of the account just inserted and send it via email to a specific address.
Please note that:

- you can use any name for hooks functions, but the name MUST start with dadabik_ 

- if you need to execute operations on the database, you have to add the global $conn; code line (as in the example)

- the after insert, update and delete hook functions receive as parameter the value of the primary key field of the record just inserted (if it is an autoincrement field), updated or deleted, the before update hook function receives as input the value of the PK of the field in update and (second parameter of the function) an associative array containing all the values the user filled in the update form (where the array element's key is the name of the field).

- the delete hook doesn't work after a "delete all" operation.

- You don't have to worry about transactions in your code: the after insert, update and delete hook functions are executed inside a transaction that starts before the insert, update and delete operations are executed and ends after theh hook functions execution; the before update hook is also inside the same transaction which starts before its execution.

 
*/
/*
$hooks['accounts']['insert']['after'] = 'dadabik_send_notice_after_accounts_insert';

function dadabik_send_notice_after_accounts_insert($id_account)
{
    global $conn;

    // get the name from the ID
    $sql = "SELECT name_account FROM accounts WHERE id_account = :id_account";
    
    $res_prepare = prepare_db($conn, $sql);

    $res_bind = bind_param_db($res_prepare, ':id_account', $id_account);
    
    $res = execute_prepared_db($res_prepare,0);
    
    $row = fetch_row_db($res_prepare)
    
    mail ('john@mysite.com', 'New account inserted', 'A new account ('.$row['name_account'].') has been added.');
    
}
*/

/*

An example of $function_user_values (see $function_user_values parameter in config.php)
function dadabik_capitalize($value)
{
    return mb_strtoupper($value);
}

*/


?>
