<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>

<p><font size="+1">How to configure a DaDaBIK application</font></p>
<p>From this Admin area you can edit the DaDaBIK application you have created.</p>

<p>During the installation, DaDaBIK by default creates a <strong>page</strong> for each table in your database, this page contains a standard report (a results grid that represents the records you have in your table) and the forms to insert new records, edit existing records and search for specific records.</p>

<p>You can customize those pages in several ways, here are some you might want to try:<p>

<ul>

<li>You want to change a label or a field type? Use the <a href="internal_table_manager.php">Forms Configurator</a></li><br/>

<li>You want to hide a field from a form? Use the <a href="permissions_manager.php">Permissions Manager</a>, choose the users group you want to set the permissions for and set NO for any particular field/form combination you want to remove.</li><br/>

<li>You want to synchronize your application after having modified your DB schema (e.g. you added a new field to a table)? Use  <a href="db_synchro.php">DB Synchro</a>.</li><br/>

</ul>

<p>Using the <a href="internal_table_manager.php">Forms Configurator</a> and the <a href="permissions_manager.php">Permissions Manager</a> you will probably cover most of your customization needs. Consider the use of <strong>lookup fields</strong> (in Forms Configurator choose select_single as field type and see the lookup parameters), <strong>calculated fields</strong> and <strong>custom formatting functions</strong>, which are very powerful tools.</p>

<p>Sometimes the default pages created by DaDaBIK (one for each table) are not enough, maybe you need a report page based on two or more tables and the lookup fields can't solve your needs, or you might need particular filters. In theses case you can simply crate a Database View using custom SQL code and <strong>install</strong> the view as the source of a <strong>page</strong>, exactly as you do  with "normal" tables. You can do that from the <a href="tables_inclusion.php">pages</a> section; from such section you can also set all the other parameters about the <strong>pages</strong> of your application.</p>

<p>Finally, you can also create completely custom HTML or PHP pages, write your own code and add the pages to your DaDaBIK applications, these are called <strong>custom pages</strong> and you can set them from the	 <a href="tables_inclusion.php">pages</a> section.</p>

<p>Consider that some additional general configuration parameters can be directly set from the file /include/config.php, just by opening it with a plain text editor and editing it. At that level you can, for example, set the database you want to manage with DaDaBIK or enable/disable/configure some DaDaBIK features (e.g. authentication, upload, email notices, language,...).</p>

<p>Have fun :)</p>