<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>
<?php
include ("./include/config.php");

if ($db_library === 'adodb'){
	include('./include/adodb'.DADABIK_ADODB_VERSION.'/adodb.inc.php');
	
	// hack for oracle, all field names fetched in lower case
	if ($dbms_type === 'oci8po') {
		define('ADODB_ASSOC_CASE', 0); 
	} // end if
}
include ("./include/functions.php");
include ("./include/common_start.php");
if (isset($_SESSION['language']) && in_array($_SESSION['language'], $languages_ar)){
	$language = $_SESSION['language'];
}
else{
	$language = $languages_ar[0];
}
include ("./include/languages/".$language.".php");
$page_name = 'login';
include ("./include/check_installation.php");
include ("./include/check_table.php");
require ('./include/PasswordHash.php');
include ("./include/header.php");




// HTTP Variables:
/***************** GET ***************************
***************************************************/

// the function of this page I wanto to execute ('show_login_form'|'logout'|....)
// check_login.php, show_login_form, index.php footer - logout
if (isset($_GET["function"])){ // from the homepage
	$function = $_GET["function"];
} // end
else{
	$function = "show_login_form";
} // end else

/***************** POST ***************************
All the field contents come from POST, and I use them directly ($_POST)


***************************************************/

$show_record_numbers_change_table = 0;


switch($function){
	case 'check_login':
		if ( $_POST['username_user'] === '' || $_POST['password_user'] === '') {
			txt_out('<div class="msg_error"><p>'.$login_messages_ar['username_password_are_required'].'.</p></div>');
			include './include/forms/login.php';
		} // end if
		else{



			$ldap_authentication = 0;
			
			
			
			// how many failed attempts?
			$sql = "SELECT COUNT(*) FROM ".$quote.$prefix_internal_table.'failed_login'.$quote." WHERE username_user = '".$_POST['username_user']."'";				
			$res = execute_db($sql, $conn);
			$row = fetch_row_db($res);
			$failed_attempts = $row[0];
			
			if ($failed_attempts >= $number_failed_login_before_blocking){
			
				txt_out('<div class="msg_error"><p>'.$login_messages_ar['too_many_failed_login_account_blocked'].'</p></div>');
				include './include/forms/login.php';
			}
			else{	
				$_SESSION['logged_user_infos_ar'] = get_user_infos_ar_from_username_password($_POST['username_user'], unescape($_POST['password_user']), $ldap_authentication);
				//var_dump ($_SESSION['logged_user_infos_ar']);
			
				if ( $_SESSION['logged_user_infos_ar'] !== false){
					//header ('Location: '.$site_url.'index.php');
					
					// reset the failed access counter
					$sql = "DELETE FROM ".$quote.$prefix_internal_table.'failed_login'.$quote." WHERE username_user = '".$_POST['username_user']."'";		
					$res = execute_db($sql, $conn);
					
					
					// default solution
					$url_temp = $site_url.$dadabik_main_file.'?empty_search_variables=1';

					$allowed_redirect_scripts_ar = array('index.php','admin.php','internal_table_manager.php','permissions_manager.php','tables_inclusion.php','datagrid_configurator.php','db_synchro.php');

					if ( isset($_SESSION['redirect_uri_after_login']) ){
						// e.g. index.php?function=show_results
						$script_name_querystring = basename($_SESSION['redirect_uri_after_login']);
						if ( $script_name_querystring === 'admin.php?function=show_users'){
							$url_temp = $site_url.$script_name_querystring;
						}
						else{
							foreach($allowed_redirect_scripts_ar as $value){
								if (substr($script_name_querystring, 0, strlen_custom($value)) === $value){
									$url_temp = $site_url.$value;
									if ($value === 'index.php' ){
										$url_temp .= '?empty_search_variables=1';
									}
									break;
								}
							}
						}
						
						unset($_SESSION['redirect_uri_after_login']);
					}
					else{ // it never happens unless I call directly the login.php file wtihtou passing by index or admin
						$url_temp = $site_url.$dadabik_main_file.'?empty_search_variables=1';
					}
					
					header('Location:'.$url_temp);
					
					die();
				} // end if
				else{
					unset($_SESSION['logged_user_infos_ar']);
				
					$sql = "INSERT INTO ".$quote.$prefix_internal_table.'failed_login'.$quote." (timestamp_failed_login, username_user) values (".time().", '".$_POST['username_user']."')";
						
					$res = execute_db($sql, $conn);
				
					txt_out('<div class="msg_error"><p>'.$login_messages_ar['incorrect_login'].'.</p></div>');
					
					if ( ($number_failed_login_before_blocking-$failed_attempts-1) < 4 ){
						txt_out('<div class="msg_error"><p> '.$login_messages_ar['warning_you_still_have'].'<br>'.($number_failed_login_before_blocking-$failed_attempts-1).$login_messages_ar['attempts_before_account_blocking'].'</p></div>');
					}
					
					
					include './include/forms/login.php';
				} // end else
			}
		} // end else
		
		break; // case 'check_login'
	case 'logout':
		unset($_SESSION['logged_user_infos_ar']);


		session_unset();

		
		header ('Location: '.$site_url.$dadabik_login_file);
		die();
		break; // case 'logout'
	case 'show_login_form':
		include './include/forms/login.php';
		break; // case 'show_login_form'
} // end swtich ($function)

// include footer
include ("./include/footer.php");
?>
