<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>
<?php
include ("./include/config.php");
include ("./include/functions.php");
include ("./include/common_start.php");
include ("./include/check_installation.php");
include ("./include/check_admin_login.php");

$page_name = 'permissions_manager';
$_SESSION['current_admin_page'] = 'permissions_manager.php';


// variables:
// GET
// $table_name
// POST
// 
// $function from this page ("delete_records", "refresh_table",......)

// get the array containing the names of the tables installed
$installed_tables_ar = build_tables_names_array(0, 1, 1);


if (isset($_POST["object"]) && $_POST["object"] !== ''){ // object is always the table name, $object_to_set is the table name or table.field_name, might by '' when you copy permissions from one group to another for all tables
	$table_name = $_POST["object"]; // just for passing over
} // end if
else{
	if (isset($_GET["tablename"])){
		$table_name = $_GET["tablename"];
	} // end if
	elseif (count($installed_tables_ar)>0){
		// get the first table
		$table_name = $installed_tables_ar[0];
		
		// override if there is at least one non admin table
		foreach ($installed_tables_ar as $installed_tables_ar_el){
			if ($installed_tables_ar_el !== $users_table_name && $installed_tables_ar_el !== $groups_table_name && $installed_tables_ar_el !== $prefix_internal_table.'static_pages' ){
				$table_name = $installed_tables_ar_el;
				break;
			}
		}
	} // end if
} // end else

if (!in_array($table_name, $installed_tables_ar)){
	header('Location:'.$site_url.'permissions_manager.php');
}

if (isset($_GET["function"])){
	$function = $_GET["function"];
} // end if
elseif (isset($_POST["function"])){
	$function = $_POST["function"];
} // end if
else{
	$function = '';
} // end if

// e.g. 'customers'
if (isset($_POST["object"])){
	$object = $_POST["object"];
} // end if

// e.g. 'user_12' or 'group_1'
if (isset($_POST["subject"])){
	$subject = $_POST["subject"];
} // end if

if (isset($_POST["change_subject_object"])){
	$change_subject_object = (int)$_POST["change_subject_object"];
} // end if

if (isset($_POST["object_to_set"])){
	$object_to_set = $_POST["object_to_set"];
} // end if

if (isset($_POST["object_type_to_set"])){
	$object_type_to_set = $_POST["object_type_to_set"];
} // end if

if (isset($_POST["subject_to_set"])){
	$subject_to_set = $_POST["subject_to_set"];
} // end if

if (isset($_POST["set_permissions"])){
	$set_permissions = (int)$_POST["set_permissions"];
} // end if

if (isset($_POST["enable_insert"])){
	$enable_insert = $_POST["enable_insert"];
} // end if
if (isset($_POST["enable_edit"])){
	$enable_edit = $_POST["enable_edit"];
} // end if
if (isset($_POST["enable_delete"])){
	$enable_delete = $_POST["enable_delete"];
} // end if
if (isset($_POST["enable_details"])){
	$enable_details = $_POST["enable_details"];
} // end if
if (isset($_POST["enable_list"])){
	$enable_list = $_POST["enable_list"];
} // end if
if (isset($_POST["enable_delete_authorization"])){
	$enable_delete_authorization = $_POST["enable_delete_authorization"];
} // end if
if (isset($_POST["enable_update_authorization"])){
	$enable_update_authorization = $_POST["enable_update_authorization"];
} // end if
if (isset($_POST["enable_browse_authorization"])){
	$enable_browse_authorization = $_POST["enable_browse_authorization"];
} // end if

$confirmation_message = "";
$error_message = "";
$alert_message = '';


if (isset($table_name)){
	// build the select with all installed table
	$change_table_select = build_change_table_select(0, 1);
	$table_internal_name = $prefix_internal_table.$table_name;
} // end if


include ("./include/header.php");
?>



<?php

if ($enable_granular_permissions === 1 && $enable_authentication === 1 ){

	

	if ($function === 'copy_permissions'){

		
	}
	else{
		// id, type (read, delete, etc), object_type (table|field), options (0,1,...)
		$permission_types_ar = build_permission_types_ar();

		$missing_required_fields = 0;
		if (isset($change_subject_object) && $change_subject_object === 1 && ($object === '' || $subject === '')){
			$error_message .= 'Please select both the table and the group';
		
			$missing_required_fields = 1;
		}
	
		if (isset($set_permissions) && $set_permissions === 1){
		
			switch($object_type_to_set){
				case 'field':
					$object_lists_ar = build_fields_labels_array($prefix_internal_table.$object, 1);
				
					foreach($object_lists_ar as $key => $value){
						$object_lists_ar[$key] = $object.'.'.$value['name_field'];
						$field_names_ar[$key] = $value['name_field'];
					}
					break;
				case 'table':
					$object_lists_ar[0] = $object_to_set;
					$field_names_ar[0] = $object_to_set;
					break;
			}
		
		
		
			if (substr_custom($subject_to_set, 0, 5) === 'user_'){
				$subject_type_permission = 'user';
				$id_subject = substr_custom($subject_to_set, 5);
			}
			elseif(substr_custom($subject_to_set, 0, 6) === 'group_'){
				$subject_type_permission = 'group';
			
				$id_subject = substr_custom($subject_to_set, 6);
			
				$sql = "SELECT ".$quote.$users_table_id_field.$quote." from ".$quote.$users_table_name.$quote." WHERE ".$quote.$users_table_id_group_field.$quote." = '".$id_subject."'";
			
				$res = execute_db($sql, $conn);
			
				$users_belonging_ar = array();
			
				while ($row = fetch_row_db($res)){
					$users_belonging_ar[] = $row[$users_table_id_field];
				}
			}
			else{
				die('General error subject prefix');
			}
		
			begin_trans_db();
		
			foreach($object_lists_ar as $key => $object_lists_ar_el){
			
				$object_to_set = $object_lists_ar_el;
				$field_name = $field_names_ar[$key];
		
				$sql = "DELETE FROM ".$quote.$prefix_internal_table."permissions".$quote." WHERE subject_type_permission = '".$subject_type_permission."' AND id_subject = '".$id_subject."' AND object_permission = '".$object_to_set."'";
	
				$res = execute_db($sql, $conn);
				
				
				// dadabik 7, no user permissions
				
				/*
				// new approach 27/11/14
				$users_or = '';
				if (isset($users_belonging_ar)){
					foreach ($users_belonging_ar as $users_belonging_ar_el){
						$users_or .= "id_subject = '".$users_belonging_ar_el."' OR ";
					}
				
					$users_or = substr($users_or, 0, -4);
				
					$sql = "DELETE FROM ".$quote.$prefix_internal_table."permissions".$quote." WHERE subject_type_permission = 'user' AND (".$users_or.") AND object_permission = '".$object_to_set."'";
					$res = execute_db($sql, $conn);
					//echo '<p>'.$sql;
				}
				*/
			
				// old approach
				/*
				if (isset($users_belonging_ar)){
				foreach ($users_belonging_ar as $users_belonging_ar_el){
					$sql = "DELETE FROM ".$quote.$prefix_internal_table."permissions".$quote." WHERE subject_type_permission = 'user' AND id_subject = '".$users_belonging_ar_el."' AND object_permission = '".$object_to_set."'";
	
					$res = execute_db($sql, $conn);
					}
				}
				*/
			
				foreach($permission_types_ar as $permission_types_ar_el){
					if ($permission_types_ar_el['object_type_permission_type'] == $object_type_to_set){
				
						if (!isset($_POST[$field_name.'_'.$id_subject.'_'.$permission_types_ar_el['id_permission_type']])){
							die('Error with permissions form');
						}
						
						$sql = "INSERT INTO  ".$quote.$prefix_internal_table."permissions".$quote." (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) VALUES ('".$subject_type_permission."', ".$id_subject.", '".$object_type_to_set."', '".$object_to_set."', ".$permission_types_ar_el['id_permission_type'].", '".$_POST[$field_name.'_'.$id_subject.'_'.$permission_types_ar_el['id_permission_type']]."')";
						
						$res = execute_db($sql, $conn);
					
						// dadabik 7, no user permission
						/*
						// new version 27/11/14
						$insert_values = '';
						if (isset($users_belonging_ar)){
							foreach ($users_belonging_ar as $users_belonging_ar_el){
								$insert_values .= "('user', ".$users_belonging_ar_el.", '".$object_type_to_set."', '".$object_to_set."', ".$permission_types_ar_el['id_permission_type'].", '".$_POST[$field_name.'_'.$id_subject.'_'.$permission_types_ar_el['id_permission_type']]."'),";
							}
						
							$insert_values = substr($insert_values, 0, -1);
						
							$sql = "INSERT INTO  ".$quote.$prefix_internal_table."permissions".$quote." (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) VALUES ".$insert_values;
							$res = execute_db($sql, $conn);
						}
						*/
					
					
						/* old version 
						if (isset($users_belonging_ar)){
							foreach ($users_belonging_ar as $users_belonging_ar_el){
								$sql = "INSERT INTO  ".$quote.$prefix_internal_table."permissions".$quote." (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) VALUES ('user', ".$users_belonging_ar_el.", '".$object_type_to_set."', '".$object_to_set."', ".$permission_types_ar_el['id_permission_type'].", '".$_POST[$field_name.'_'.$id_subject.'_'.$permission_types_ar_el['id_permission_type']]."')";
			
								$res = execute_db($sql, $conn);
							}
						}
						*/
					}
				}
			}
		
			complete_trans_db();
		
			$confirmation_message .= 'Permissions updated';
		
		}

		if (isset($object)){
	
			$object = unescape($object);
		
			$objects_select = build_objects_select($object, ' onchange="if ($(\'#subject\').val() !== \'\' && $(\'#object\').val() !== \'\') { this.form.submit(); }"');
		
		}
		else{
			$objects_select = build_objects_select($table_name, ' onchange="if ($(\'#subject\').val() !== \'\' && $(\'#object\').val() !== \'\') { this.form.submit(); }"');
		}
	
		if (isset($subject)){
	
		
			$subject = unescape($subject);
		
			$subjects_select = build_subjects_select($subject,'subject', ' onchange="if ($(\'#subject\').val() !== \'\' && $(\'#object\').val() !== \'\') { this.form.submit(); }"');
		
		}
		else{
			$subjects_select = build_subjects_select('', 'subject', ' onchange="if ($(\'#subject\').val() !== \'\' && $(\'#object\').val() !== \'\') { this.form.submit(); }"');
		}
		
		echo '<span id="confirmation_message_container">';	
		if ($confirmation_message != ""){
			echo '<div class="msg_ok" id="confirmation_message"><p>'.$confirmation_message.'<br/><br/><a href="javascript:{}" id="confirmation_message_close_link">Ok, close</a></p></div>';
		} // end if
		if ($error_message != ""){
			echo '<div class="msg_error" id="error_message"><p>'.$error_message.'<br/><br/><a href="javascript:{}" id="error_message_close_link">Ok, close</a></p></div>';
		} // end if
		if ($alert_message != ""){
			echo '<div class="msg_alert" id="alert_message"><p>'.$alert_message.'<br/><br/><a href="javascript:{}" id="alert_message_close_link">Ok, close</a></p></div>';
		} // end if
		echo '</span>';
	
		echo '<p><font size="+1">Configure the permissions for the table <b>'.$table_name.'</b>';
		echo '</font></p>';
		echo '<form method="POST" action="permissions_manager.php?tablename='.urlencode($table_name).'"><input type="hidden" name="change_subject_object" value="1"><p>Choose a table: '.$objects_select.'&nbsp;&nbsp;&nbsp;&nbsp; choose a group: '.$subjects_select.' <br/><br/></form>';
	
		if (isset($object) && isset($subject) && $missing_required_fields === 0){
	
		
			echo '<table  cellpadding="6" ><tr class="tr_form_separator"><td colspan="9">Step 1: set permissions for the table '.$table_name.' (table-level permissions)</td></tr>';
		
			echo '<tr><td colspan="9">For each permission, choose Yes or No. For Read, Delete and Edit you also have the option MY, which enables the owner permissions';
			
			
			echo ' <a href="javascript:show_admin_help(\'What is the owner permissions model?\',\'The <b>owner permissions model</b> allows to set-up the application in a way such as users can:

	<ul>
	<li>Delete ONLY their own records
	<li>Modify ONLY their own records
	<li>View ONLY their own records
	</ul>
	The owner of a record is the user who created it. 
	The table you want to protect with owner permissions must have a field whose field type is set to <i>ID_user</i>. This field, during a record insertion, will be automatically filled by DaDaBIK using the <i>username</i> of the current user. If you prefer a group-based owner permission model, set $use_id_group_for_ownership to 1 in config.php.\');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a>';

	echo '(the owner permissions have effect only with DaDaBIK ENTERPRISE VERSION). ';

	
	
	echo '</td></tr>';
		
		
		 
		 
			if (substr_custom($subject, 0, 5) === 'user_'){
				$id_user = substr_custom($subject, 5);
							
				$user_infos_ar = get_user_infos_ar_from_username_password($id_user, '', 0, 1, 1);
			
			
				$subjects_ar[0]['name'] = $user_infos_ar['username_user'];
				$subjects_ar[0]['id'] = $user_infos_ar['id_user'];
			
				$subjects_ar[0]['permissions'] = $user_infos_ar['permissions']['user'];
			
			
			}
			elseif(substr_custom($subject, 0, 6) === 'group_'){
				$id_group = substr_custom($subject, 6);
							
				$group_infos_ar = build_group_infos_ar($id_group);
			
			
				$subjects_ar[0]['name'] = $group_infos_ar['name_group'];
				$subjects_ar[0]['id'] = $group_infos_ar['id_group'];
			
				$subjects_ar[0]['permissions'] = $group_infos_ar['permissions'];
			}
			/*
			elseif(substr_custom($subject, 0, 10) === 'all_groups'){
			
				$all_groups_infos_ar = build_group_infos_ar('');
			
				$sql = ""
			
			
			
			}
			elseif(substr_custom($subject, 0, 9) === 'all_users'){
			}
			*/
			else{
				die('General error subject prefix');
			}
		
			echo '<form method="POST" action="permissions_manager.php?tablename='.urlencode($table_name).'">';
			echo '<input type="hidden" name="object_type_to_set" value="table">';
			echo '<input type="hidden" name="object" value="'.$object.'">';
			echo '<input type="hidden" name="subject" value="'.$subject.'">';
			echo '<input type="hidden" name="object_to_set" value="'.$object.'">';
			echo '<input type="hidden" name="subject_to_set" value="'.$subject.'">';
			echo '<input type="hidden" name="set_permissions" value="1">';
		
		
			echo '<tr><td></td>';
			foreach($permission_types_ar as $permission_types_ar_el){
				if ($permission_types_ar_el['object_type_permission_type'] == 'table'){
					echo '<td align="left" style="padding:0 10px 0 10px;">'.strtoupper_custom($permission_types_ar_el['type_permission_type']);
				
					if ($permission_types_ar_el['id_permission_type'] == '1'){
						echo " <a href=\"javascript:show_admin_help('Read permission:', 'If you disable the read permission, the correspondent table page will not be displayed in the menu of the application (except for Users and Groups pages, just for admin users). Remember, however, that users can still read its records if the table is used as source of a select_single/select_multiple field or as items table in a master/details view.');\"><img alt=\"Help\" title=\"Help\" border=\"0\" src=\"images/help.png\" /></a>";
					}
					echo '</td>';
				
				}
			}
			echo '<td></td><td></td><td></td>';
			echo '</tr>';
			foreach($subjects_ar as $subjects_ar_el){
				$js_yes_all = '';
				$js_no_all = '';
				echo '<tr>';
				echo '<td><b>'.$subjects_ar_el['name'].'</b></td>';
			
				foreach($permission_types_ar as $permission_types_ar_el){
		
					if ($permission_types_ar_el['object_type_permission_type'] == 'table'){
						$permission_info_available = 0;
				
				
						foreach($subjects_ar_el['permissions'] as $temp){ // for each permission of the subject
						
						
							if ($temp['id_permission_type'] == $permission_types_ar_el['id_permission_type'] && $temp['object_permission'] == $object){
						
								$value_permission = $temp['value_permission'];
								$permission_info_available = 1;
								break;
							}
						}
					
						if ($permission_info_available === 0){
							$value_permission = 0;
						}
					
					
						echo '<td align="left" style="padding:0 10px 0 10px;">'.build_permission_options_select($permission_types_ar, $subjects_ar_el['id'], $permission_types_ar_el['id_permission_type'], $value_permission, $object).'</td>';
					
						$js_yes_all .= 'document.getElementById(\''.$object.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'1\';';
						$js_no_all .= 'document.getElementById(\''.$object.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'0\';';
					}
				}
			
			
				echo '<td><div style="cursor:pointer;color:#66603c;text-decoration:underline;" onclick="javascript:'.$js_yes_all.'">Yes for all</div></td><td><div style="cursor:pointer;color:#66603c;text-decoration:underline;" onclick="javascript:'.$js_no_all.'">No for all</div></td><td><input value="SAVE" class="button_admin" type="submit"></td></tr>';
			}
			echo '<tr><td colspan="8">&nbsp;</td></tr>';
			echo '</table>';
		
			echo '</form>';
		
		
			echo '<form method="POST" action="permissions_manager.php?tablename='.urlencode($table_name).'">';
			echo '<input type="hidden" name="subject" value="'.$subject.'">';
			echo '<input type="hidden" name="subject_to_set" value="'.$subject.'">';
			echo '<input type="hidden" name="set_permissions" value="1">';
			echo '<input type="hidden" name="object_type_to_set" value="field">';
			echo '<input type="hidden" name="object" value="'.$object.'">';
			echo '<table cellpadding="6" ><tr><td colspan="9">&nbsp;</td></tr><tr class="tr_form_separator"><td colspan="9">Step 2: set permissions for each field (field-level permissions)</td></tr>';
			
			// new_interface_nov_2014
			$fields_labels_ar = build_fields_labels_array($prefix_internal_table.$object, 1);
			
			// this code is duplicated
			$js_yes_all_global = ''; // yes for every fields, every permissions
			$js_no_all_global = ''; // no for every fields, every permissions
			foreach($subjects_ar as $subjects_ar_el){
				foreach($permission_types_ar as $permission_types_ar_el){
					if ($permission_types_ar_el['object_type_permission_type'] == 'field'){
						foreach($fields_labels_ar as $fields_labels_ar_el){
							$fields_ar_el = $fields_labels_ar_el['name_field'];
					
							$js_yes_all_global .= 'document.getElementById(\''.$fields_ar_el.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'1\';';
							$js_no_all_global .= 'document.getElementById(\''.$fields_ar_el.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'0\';';
						
							
						}
					}
				}
			}
		
			echo '<tr><td colspan="9">For each field of the table <b>'.$table_name.'</b>, choose Yes/No to set if the field must appear in the results grid, edit, create, details, quick search and search forms. You can also <span style="cursor:pointer;color:#66603c;text-decoration:underline;" onclick="javascript:'.$js_yes_all_global.'">set yes for all fields/permissions</span> or <span style="cursor:pointer;color:#66603c;text-decoration:underline;" onclick="javascript:'.$js_no_all_global.'">set no for all fields/permissions</span></span>. Please note that if you set to NO a permission on a table level, for example the edit permission, all the fields will be NOT editable, regardless of the actual setting on a field-level. </td></tr>';
		
			echo '</table>';
			echo '<table border=0>';
			echo '<tr><td colspan="9">&nbsp;</td></tr>';
		
		
			//$fields_ar = get_fields_list($object);
		
			
		
		
			echo '<tr><td colspan="9"><b>SET FOR ALL FIELDS:</b></td></tr>';
			
			
			
			echo '<tr><td></td>';
			foreach($permission_types_ar as $permission_types_ar_el){
				if ($permission_types_ar_el['object_type_permission_type'] == 'field'){
					echo '<td align="left" style="padding:0 10px 0 10px;">'.strtoupper_custom($permission_types_ar_el['type_permission_type']).'</td>';
				}
			}
			echo '<td></td><td></td>';
			echo '</tr>';
			foreach($subjects_ar as $subjects_ar_el){
				$js_yes_all = '';
				$js_no_all = '';
				$js_yes_all_global = ''; // yes for every fields, every permissions
				$js_no_all_global = ''; // no for every fields, every permissions
				echo '<tr>';
				echo '<td><b>'.$subjects_ar_el['name'].'</b></td>';
				
				foreach($permission_types_ar as $permission_types_ar_el){
		
					$js_yes_all_2 = '';
					$js_no_all_2 = '';
					
					foreach($fields_labels_ar as $fields_labels_ar_el){
						$fields_ar_el = $fields_labels_ar_el['name_field'];
		
						$js_yes_all_2 .= 'document.getElementById(\''.$fields_ar_el.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'1\';';
						$js_no_all_2 .= 'document.getElementById(\''.$fields_ar_el.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'0\';';
						
						$js_yes_all_global .= 'document.getElementById(\''.$fields_ar_el.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'1\';';
						$js_no_all_global .= 'document.getElementById(\''.$fields_ar_el.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'0\';';
					}
				
				
					if ($permission_types_ar_el['object_type_permission_type'] == 'field'){
				
						echo '<td style="padding:0 10px 0 10px;"><span style="cursor:pointer;color:#66603c;text-decoration:underline;" onclick="javascript:'.$js_yes_all_2.'">Yes for all</span><br/><span style="cursor:pointer;color:#66603c;text-decoration:underline;" onclick="javascript:'.$js_no_all_2.'">No for all</span></td>';
				
					}
				}
			}
			
			//echo '</table>';;
		
			//echo '<table>';
			// end new_interface_nov_2014
			echo '<tr><td colspan="9">&nbsp;</td></tr><tr><td colspan="9">&nbsp;</td></tr>';
			
			
		
			// new_interface_nov_2014
			echo '<tr><td colspan="9"><b>SET FOR EACH FIELD INDIVIDUALLY:</b></td></tr>';
			// end new_interface_nov_2014
			
			echo '<tr><td colspan="9">&nbsp;</td></tr><tr><td colspan="9"><input value="save permissions for ALL FIELDS of the table '.$table_name.'" class="button_admin" type="submit"></td></tr><tr><td colspan="9">&nbsp;</td></tr>';
			
			$c_temp = 0;
		
			foreach($fields_labels_ar as $fields_labels_ar_el){
			
				
				$fields_ar_el = $fields_labels_ar_el['name_field'];
				
				
			
				echo '<tr><td colspan="9"><b>Field: </b>'.$fields_ar_el.'</td></tr>';
			
				echo '<tr><td></td>';
				foreach($permission_types_ar as $permission_types_ar_el){
					if ($permission_types_ar_el['object_type_permission_type'] == 'field'){
						echo '<td align="left" style="padding:0 10px 0 10px;">'.strtoupper_custom($permission_types_ar_el['type_permission_type']).'</td>';
					}
				}
				echo '<td></td><td></td>';
				echo '</tr>';
				foreach($subjects_ar as $subjects_ar_el){
					$js_yes_all = '';
					$js_no_all = '';
					echo '<tr>';
					echo '<td><b>'.$subjects_ar_el['name'].'</b></td>';
				
				
					foreach($permission_types_ar as $permission_types_ar_el){
			
						if ($permission_types_ar_el['object_type_permission_type'] == 'field'){
							$permission_info_available = 0;
							
							foreach($subjects_ar_el['permissions'] as $temp){
							
								if ($temp['id_permission_type'] == $permission_types_ar_el['id_permission_type'] && $temp['object_type_permission'] == 'field' && $temp['object_permission'] == $object.'.'.$fields_ar_el){
							
									$value_permission = $temp['value_permission'];
									$permission_info_available = 1;
									break;
								}
							}
						
							if ($permission_info_available === 0){
								$value_permission = 0;
							}
						
						
							echo '<td align="left" style="padding:0 10px 0 10px;">'.build_permission_options_select($permission_types_ar, $subjects_ar_el['id'], $permission_types_ar_el['id_permission_type'], $value_permission, $fields_ar_el).'</td>';
						
							$js_yes_all .= 'document.getElementById(\''.$fields_ar_el.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'1\';';
							$js_no_all .= 'document.getElementById(\''.$fields_ar_el.'_'.$subjects_ar_el['id'].'_'.$permission_types_ar_el['id_permission_type'].'\').value=\'0\';';
						}
					}
					echo '<td><div style="cursor:pointer;color:#66603c;text-decoration:underline;" onclick="javascript:'.$js_yes_all.'">Yes for all</div></td><td><div style="cursor:pointer;color:#66603c;text-decoration:underline;" onclick="javascript:'.$js_no_all.'">No for all</div></td></tr>';
					
					$c_temp++;
					
					// every 5 rows show the save button
					if (  $c_temp % 5 === 0){
		
						echo '<tr><td colspan="9">&nbsp;</td></tr><tr><td colspan="9"><input value="save permissions for ALL FIELDS of the table '.$table_name.'" class="button_admin" type="submit"></td></tr>';
						
						$save_button_just_displayed = 1;
					
					}
					else{
						$save_button_just_displayed = 0;
					}
				}
				//echo '</table>';
			
				//echo '<input value="save permissions for '.$fields_ar_el.'" type="submit"><br/>';
			
				//echo '<table border=1>';
				echo '<tr><td colspan="9">&nbsp;</td></tr>';
			}
			echo '</table>';
			
			if ($save_button_just_displayed === 0){
			
				echo '<input value="save permissions for ALL FIELDS of the table '.$table_name.'" class="button_admin" type="submit">';
			
			}
			echo '</form>';
		}
	}
}
elseif ($enable_granular_permissions === 0 || $enable_authentication === 0){
	switch($function){
		case "enable_features":
			if (!isset($enable_insert)){
				$enable_insert = "0";
			} // end if
	
			if (!isset($enable_edit)){
				$enable_edit = "0";
			} // end if
	
			if (!isset($enable_delete)){
				$enable_delete = "0";
			} // end if
	
			if (!isset($enable_details)){
				$enable_details = "0";
			} // end if
	
			if (!isset($enable_list)){
				$enable_list = "0";
			} // end if
	
			if (!isset($enable_delete_authorization)){
				$enable_delete_authorization = "0";
			} // end if
	
			if (!isset($enable_update_authorization)){
				$enable_update_authorization = "0";
			} // end if
	
			if (!isset($enable_browse_authorization)){
				$enable_browse_authorization = "0";
			} // end if
	
			// save the configuration about features enabled
			$sql = "update ".$quote."$table_list_name".$quote." set ".$quote."enable_insert_table".$quote." = '".$enable_insert."', ".$quote."enable_edit_table".$quote." = '".$enable_edit."', ".$quote."enable_delete_table".$quote." = '".$enable_delete."', ".$quote."enable_details_table".$quote." = '".$enable_details."', ".$quote."enable_list_table".$quote." = '".$enable_list."', ".$quote."enable_delete_authorization_table".$quote." = '".$enable_delete_authorization."', ".$quote."enable_update_authorization_table".$quote." = '".$enable_update_authorization."', ".$quote."enable_browse_authorization_table".$quote." = '".$enable_browse_authorization."' where ".$quote."name_table".$quote." = '$table_name'";
	
			// execute the update
			$res_update = execute_db($sql, $conn);
	
			$confirmation_message .= "Changes correctly saved.";
			break;
	}
}

?>


<?php if($enable_granular_permissions === 0 || $enable_authentication === 0){ ?>


<span id="confirmation_message_container">
<?php
if ($confirmation_message != ""){
	echo '<div class="msg_ok" id="confirmation_message"><p>'.$confirmation_message.'<br/><br/><a href="javascript:{}" id="confirmation_message_close_link">Ok, close</a></p></div>';
} // end if
if ($error_message != ""){
	echo '<div class="msg_error" id="error_message"><p>'.$error_message.'<br/><br/><a href="javascript:{}" id="error_message_close_link">Ok, close</a></p></div>';
} // end if
if ($alert_message != ""){
	echo '<div class="msg_alert" id="alert_message"><p>'.$alert_message.'<br/><br/><a href="javascript:{}" id="alert_message_close_link">Ok, close</a></p></div>';
} // end if
?>
</span>


<p><font size="+1">Configure the permissions for the table <b><?php echo $table_name; ?></b></font></p>
<p>For a granular configuration, i.e. setting the permissions for each table/usergroup and field/usergroup couple, you need to enable authentication and  granular permissions in <strong>/include/config.php</strong></p>

<?php
if ($change_table_select != ""){
?>
<form method="get" action="permissions_manager.php" name="change_table_form"><input type="hidden" name="function" value="change_table">
<?php echo $change_table_select; ?>
<?php
if (  false && $autosumbit_change_table_control == 0) {
?>
<input type="submit" value="Change table">
<?php
}
else{
?>
 Change table
<?php
}
?>

</form>
<?php
}

$enable_features_checkboxes = build_enable_features_checkboxes($table_name);

$only_include_allowed = 0;
$installed_table_infos_ar = build_installed_table_infos_ar($only_include_allowed, 1);

foreach ($installed_table_infos_ar as $installed_table_infos) {
	if ($installed_table_infos['name_table'] === $table_name) {
		$table_alias = $installed_table_infos['alias_table'];
		$enable_template_table = $installed_table_infos['enable_template_table'];
		$template_table = $installed_table_infos['template_table'];
	} // end if
} // end while

?>

<br/><p><form method="post" action="permissions_manager.php?tablename=<?php echo urlencode($table_name); ?>"><input type="hidden" name="function" value="enable_features"><b>For this table enable:</b><br/><br/><?php echo $enable_features_checkboxes ?><br/><br/><input type="submit" class="button_admin" value="Enable/disable"></form>


<?php } ?>



<?php
// include footer
include ("./include/footer.php");
?>
