<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>
<?php
include ("./include/config.php");
include ("./include/functions.php");
include ("./include/common_start.php");
include ("./include/check_installation.php");
include ("./include/check_admin_login.php");

$page_name = 'tables_inclusion';

$_SESSION['current_admin_page'] = 'tables_inclusion.php';


// get the array containing the names of the tables installed (must be installed, allowed or not allowed (enable or not enabled)) including users table
$installed_tables_ar = build_tables_names_array(0, 1, 1);

// tablename is used just to keep stored the table we are using in the whole admin section (I should have used sessions for that but ok), for this specific script we use tablename_2 when we need to specify an action ON a table (e.g. install a table)
if (isset($_GET["tablename"])){
	$table_name = $_GET["tablename"];
} // end if
else{
	if (count($installed_tables_ar)>0){
		// get the first table
		$table_name = $installed_tables_ar[0];
		
		// override if there is at least one non admin table
		foreach ($installed_tables_ar as $installed_tables_ar_el){
			if ($installed_tables_ar_el !== $users_table_name && $installed_tables_ar_el !== $groups_table_name && $installed_tables_ar_el !== $prefix_internal_table.'static_pages' ){
				$table_name = $installed_tables_ar_el;
				break;
			}
		}
	} // end if
} // end else

if (isset($_GET["tablename_2"])){
	$table_name_2 = $_GET["tablename_2"];
} // end if


// function
if (isset($_POST["function"])){
	$function = $_POST["function"];
} // end if
elseif (isset($_GET["function"])){
	$function = $_GET["function"];
} // end if
else{
	$function = "";
} // end else

// the pages to show
if (isset($_GET["pages_to_show"])){
	$pages_to_show = $_GET["pages_to_show"];
	$_SESSION['pages_to_show'] = $pages_to_show;
} // end if
elseif (isset($_SESSION["pages_to_show"])){
	$pages_to_show = $_SESSION["pages_to_show"];
} // end if
else{
	$pages_to_show = 'tables_installed';
} // end else

include ("./include/header.php");

$confirmation_message = "";
$error_message = "";
$alert_message = '';


// build two arrays, complete_tables_names_ar and complete_tables_types_ar, containing the names and the types of all the tables installed and not, allowed and not, except from users gorups and custom pages
$temp_ar = build_tables_names_array(0, 0, 1,1);

// get all the tables except users groups and static
// code repeated after create_view
foreach ($temp_ar as $key => $temp_ar_element) {
	if ($temp_ar_element['name'] !== $users_table_name && $temp_ar_element['name'] !== $groups_table_name && $temp_ar_element['name'] !== $prefix_internal_table."static_pages"){
		$complete_tables_names_ar[]=$temp_ar_element['name'];
		$complete_tables_types_ar[]=$temp_ar[$key]['type'];
	}
}


$static_pages_ar = build_static_pages_ar();

function print_table_row($complete_tables_names_ar, $i, $index, $installed_tables_ar, $table_name, $installed, $static_pages_ar)
// $installed (0|1) means we are processing an installed table or not, $index is the incremental suffix to add to the id and name of the field; $i is the index of the table we are processing in $complete_tables_names_ar 
{	
	
	// get info about the current table in process
	$installed_table_infos_ar = get_installed_table_infos($complete_tables_names_ar[$i]);
	
	echo '<tr>';
	
	
	// alias_table_xx
	if ($installed === 1){
		echo '<td><input type="text" id="alias_table_'.$index.'" name="alias_table_'.$index.'" value="'.$installed_table_infos_ar['alias_table'].'"></td>';
	}
	
	// hidden name_table_xx and table name (label)
	echo '<td><input type="hidden" id="name_table_'.$index.'" name="name_table_'.$index.'" value="'.$installed_table_infos_ar['name_table'].'">'.$complete_tables_names_ar[$i]."</td>";
	
	echo "<td>";
	if ($installed === 1){
		echo "Yes (<a href=\"tables_inclusion.php?function=uninstall_table&tablename=".urlencode($table_name)."&tablename_2=".urlencode($complete_tables_names_ar[$i])."\">Uninstall</a>)";
	}
	else{
		echo "No (<a href=\"tables_inclusion.php?function=install_table&tablename=".urlencode($table_name)."&tablename_2=".urlencode($complete_tables_names_ar[$i])."\">Install</a>)";
	}
	echo '</td>';
	
	if ($installed === 1){
	
		// enabled field
		echo "<td>";
		echo '<input type="checkbox" name="allowed_table_'.$index.'" id="allowed_table_'.$index.'" value="1"';
		if (table_allowed($complete_tables_names_ar[$i])){
			echo " checked";
		} // end if	
		echo ">";
		echo "</td>";

		echo "<td>";
		
		$fields_ar = get_fields_list($complete_tables_names_ar[$i]);
		$pk_field = get_unique_field_db($complete_tables_names_ar[$i]);


		if (is_null($pk_field)){
			$pk_field = $fields_ar[0];
		}
		
		// primary key of the table
		echo '<select name="pk_field_table_'.$index.'" id="pk_field_table_'.$index.'">';
		echo '<option value=""></option>';
		foreach ($fields_ar as $fields_ar_el){

			echo '<option value="'.$fields_ar_el.'"';
			if ($pk_field === $fields_ar_el){
				echo ' selected';
			}
			echo '>'.$fields_ar_el.'</option>';
		}
		echo '</select>';
		echo "</td>";
		
		// order
		echo '<td nowrap><span class="tooltip"><input size="2" type="text" id="menu_order_table_'.$index.'" name="menu_order_table_'.$index.'" value="'.$installed_table_infos_ar['menu_order_table'].'"><span class="tooltip_content">The position of this item in the menu e.g. 1 means first position</span></span> / ';
		
		// separator_before_table
		//echo "<td>";
		echo '<input type="checkbox" name="separator_before_table_'.$index.'" id="separator_before_table_'.$index.'" value="y"';
		echo $installed_table_infos_ar['separator_before_table'] === 'y' ? " checked" : ''; 
		echo "> / ";
		
		// parent menu page
		/*
		echo '<select name="menu_parent_table_'.$index.'" id="menu_parent_table_'.$index.'" >';
		echo '<option value="top">TOP</option>';
		echo '<optgroup label="Pages based on tables/views">';

		foreach ($installed_tables_ar as $installed_tables_ar_el){
			echo '<option value="table_'.$installed_tables_ar_el.'"';

			if ($installed_table_infos_ar['menu_parent_table'] === 'table_'.$installed_tables_ar_el){
				echo ' selected';
			}

			echo '>'.$installed_tables_ar_el.'</option>';
		
		}
		echo '</optgroup>';
		echo '<optgroup label="Custom pages">';

		foreach ($static_pages_ar as $static_pages_ar_el){
			echo '<option value="page_'.$static_pages_ar_el['id_static_page'].'"';
			if ($installed_table_infos_ar['menu_parent_table'] === 'page_'.$static_pages_ar_el['id_static_page']){
				echo ' selected';
			}
			echo '>'.$static_pages_ar_el['link_static_page'].'</option>';
		}
		echo '</optgroup>';
		echo '</select>';
		*/
		echo '<input type="text" id="menu_parent_table_'.$index.'" name="menu_parent_table_'.$index.'" value="'.$installed_table_infos_ar['menu_parent_table'].'">';
	
		echo '</td>';
	}
	
	echo "</tr>";
}

function print_page_row($index, $static_pages_ar, $installed_tables_ar)
// $index is the incremental suffix to add to the id and name of the field
{	
	
	$static_page_infos = $static_pages_ar[$index-1];
	echo '<tr valign="top">';
	
	echo '<td><a href="tables_inclusion.php?function=delete_page&index_static_page_delete='.($index-1).'" title="delete page"><img src="images/delete.png"></a></td>';
	
	// hidden id_static_page_xx and table name (label)
	echo '<td><input type="hidden" id="id_static_page_'.$index.'" name="id_static_page_'.$index.'" value="'.$static_page_infos['id_static_page'].'"><input type="text" id="link_static_page_'.$index.'" name="link_static_page_'.$index.'" value="'.$static_page_infos['link_static_page'].'"></td>';
	
	// enabled field
	echo "<td>";
	echo '<input type="checkbox" name="enabled_static_page_'.$index.'" id="enabled_static_page_'.$index.'" value="1"';
	if ( $static_page_infos['enabled_static_page'] == 1 ){
		echo " checked";
	} // end if	
	echo ">";
	echo "</td>";

	// type page
	echo "<td>";
	
	echo '<select name="type_static_page_'.$index.'" id="type_static_page_'.$index.'">';
	echo '<option value="html"';
	echo $static_page_infos['type_static_page'] === 'html' ? ' selected' : '';
	echo ' >HTML</option>';
	echo '<option value="PHP"';
	echo $static_page_infos['type_static_page'] === 'PHP' ? ' selected' : '';
	echo '>PHP</option>';
	echo '<option value="link_int"';
	echo $static_page_infos['type_static_page'] === 'link_int' ? ' selected' : '';
	echo '>int. link</option>';
	echo '<option value="link_ext"';
	echo $static_page_infos['type_static_page'] === 'link_ext' ? ' selected' : '';
	echo '>ext. link</option>';
	echo '</select>';
	echo "</td>";
	
	// file static page
	echo "<td>";
	
	echo '<select name="file_static_page_'.$index.'" id="file_static_page_'.$index.'">';
	echo '<option value=""></option>';
	$files = array();
	if ($handle = opendir('include/custom_php_files')) {
	
		while (false !== ($file = readdir($handle))) {
			echo $file;
			if (substr($file,-4,4) === '.php'){
				$files[]=$file;
			}
		}

		closedir($handle);
	}
	
	
	foreach ($files as $file) {
		echo '<option value="'.substr($file,0,-4).'"';
		echo $static_page_infos['file_static_page'] === substr($file,0,-4) ? ' selected' : '';
		echo ' >'.$file.'</option>';
	}
	
	echo '</select>';
	echo "</td>";
	
	 // link
	 echo '<td><input type="text" id="href_link_static_page_'.$index.'" name="href_link_static_page_'.$index.'" value="'.$static_page_infos['href_link_static_page'].'"></td>';

	// content static page
	echo '<td><a href="javascript:{}" onclick="javascript:if (document.getElementById(\'content_static_page_container_'.$index.'\').style.display === \'none\') {document.getElementById(\'content_static_page_container_'.$index.'\').style.display = \'inline\'} else{document.getElementById(\'content_static_page_container_'.$index.'\').style.display = \'none\'}"
	 >Show/Hide HTML content</a></td>';
	
	// is homepage field
	echo "<td>";
	echo '<input type="checkbox" onclick="uncheck_other_homepage_checkboxes('.$index.');" name="is_homepage_static_page_'.$index.'" id="is_homepage_static_page_'.$index.'" value="y"';
	echo $static_page_infos['is_homepage_static_page'] === 'y' ? " checked" : ''; 
	echo ">";
	echo "</td>";
	
	
	
	// order
	echo '<td nowrap><span class="tooltip"><input size="2" type="text" id="menu_order_static_page_'.$index.'" name="menu_order_static_page_'.$index.'" value="'.$static_page_infos['menu_order_static_page'].'"><span class="tooltip_content">The position of this item in the menu e.g. 1 means firt position</span></span> / ';
	
	// separator_before_static_page
	//echo "<td>";
	echo '<input type="checkbox" name="separator_before_static_page_'.$index.'" id="separator_before_static_page_'.$index.'" value="y"';
	echo $static_page_infos['separator_before_static_page'] === 'y' ? " checked" : ''; 
	echo "> / ";
	//echo "</td>";
	
	// parent menu page
	/*
	echo '<select name="menu_parent_page_'.$index.'" id="menu_parent_page_'.$index.'" >';
	echo '<option value="top">TOP</option>';
	echo '<optgroup label="Pages based on tables/views">';

	foreach ($installed_tables_ar as $installed_tables_ar_el){
		echo '<option value="table_'.$installed_tables_ar_el.'"';

		if ($static_page_infos['menu_parent_page'] === 'table_'.$installed_tables_ar_el){
			echo ' selected';
		}

		echo '>'.$installed_tables_ar_el.'</option>';
	
	}
	echo '</optgroup>';
	echo '<optgroup label="Custom pages">';

	foreach ($static_pages_ar as $static_pages_ar_el){
		echo '<option value="page_'.$static_pages_ar_el['id_static_page'].'"';
		if ($static_page_infos['menu_parent_page'] === 'page_'.$static_pages_ar_el['id_static_page']){
			echo ' selected';
		}
		echo '>'.$static_pages_ar_el['link_static_page'].'</option>';
	}
	echo '</optgroup>';
	echo '</select>';
	*/
	
	echo '<input type="text" id="menu_parent_page_'.$index.'" name="menu_parent_page_'.$index.'" value="'.$static_page_infos['menu_parent_page'].'">';
	
	echo '</td>';
	
	echo "</tr>";
	
	echo '<tr><td colspan="8"><span id="content_static_page_container_'.$index.'" style="display:none"><textarea id="content_static_page_'.$index.'" name="content_static_page_'.$index.'" class="rich_editor" style="height:200px;">'.$static_page_infos['content_static_page'].'</textarea></span></td></tr>';

}


switch($function){
	case "create_view":


		if ($enable_create_view !== 1){
			$error_message .= 'View creation is disabled in config.php, please change the $enable_create_view parameter.';
		}
		elseif ($_POST['name_view'] == '' || $_POST['sql_create_view'] == ''){
			$error_message .= 'Please provide a value for the name of the View and for the SQL SELECT';
		}
		elseif($enable_semicolon_create_view === 0 && ( strpos($_POST['name_view'], ';') !== false || strpos($_POST['sql_create_view'], ';') !== false )){
			$error_message .= 'The use of semicolon (;) is not allowed for security reason, you can omit the final semicolon.<br><br>if you need a semicolon in the middle of your query, set $enable_semicolon_create_view to 1 in config.php';
		}
		else{
			$name_view = unescape($_POST['name_view']);
			$sql_create_view = unescape($_POST['sql_create_view']);
			// post values are already excaped by default, no need to do it
			$sql = "CREATE VIEW ".$quote.$name_view.$quote." AS ".$sql_create_view;
			$res = execute_db($sql, $conn, 1);
			
			if (is_array($res) && $res['error_message'] !== ''){
				$error_message .= 'Your SQL code generated an error: '.$res['error_message'];
			}
			else{
				$confirmation_message .= 'View <b>'.$name_view.'</b> has been created, you should now install it.';
				
				// switch to wiews not installed to see the view just created
				$pages_to_show = 'views_not_installed';
				$_SESSION['pages_to_show'] = 'views_not_installed';
				
				// re-build the complete list of the tables
				$complete_tables_names_ar =array();
				$complete_tables_types_ar =array();
				$temp_ar = build_tables_names_array(0, 0, 1,1);
				
				// get all the tables except users groups and static
				foreach ($temp_ar as $key => $temp_ar_element) {
					if ($temp_ar_element['name'] !== $users_table_name && $temp_ar_element['name'] !== $groups_table_name && $temp_ar_element['name'] !== $prefix_internal_table."static_pages"){
						$complete_tables_names_ar[]=$temp_ar_element['name'];
						$complete_tables_types_ar[]=$temp_ar[$key]['type'];
					}
				}
				
			}
		}



		
		break;
	case "install_table":

		
		begin_trans_db();
		
		// get the field and table names containing blanks or dots
		$items_containing_blank = check_blank_dot_names($table_name_2);
		
		if (count($items_containing_blank) > 0){
		
			$error_message .= 'For the table/view you want to install, one or more field names or the table/view name contain blank spaces or dots, here is the list:<br><b>';
			
			if (isset($items_containing_blank['fields']['field_names'])){
		
				foreach ($items_containing_blank['fields']['field_names'] as $field_name){
					$error_message .=  '<br>'.$field_name;
				}
			}
			
			if (isset($items_containing_blank['tables'])){

				foreach ($items_containing_blank['tables'] as $table_name){
					$error_message .=  '<br>'.$table_name;
				}
			}
		
			$error_message .=  '</b><br><br>Please note that DaDaBIK doesn\'t support field and table names with blank spaces or dots. Please fix the field/table names and install this table/view again.';
		}
		else{
		
			$unique_field_name = get_unique_field_db($table_name_2, 1);
		
			// get the array containing the names of the fields
			$fields_names_ar = build_fields_names_array($table_name_2);
			
			if ($grant_permissions_autoincrement_after_table_installation === 0){
                $autoincrement_field = get_autoincrement_field($table_name_2);
            }

			// delete the previous record about the table in the dadabik_tables_list table
			$sql = "delete from ".$quote.$table_list_name.$quote." where ".$quote."name_table".$quote." = '".$table_name_2."'";			
			$res_delete = execute_db($sql, $conn);		
		
			// general, non-granular permissions
			if ($grant_permissions_after_table_installation == 0){
				$enable_permissions_table = 0;
			}
			else{ // 1 or 2, for non-granular permissions it doesn't matter
				$enable_permissions_table = 1;
			}
		
			$sql = "select max(menu_order_table)+1 from ".$quote.$table_list_name.$quote." WHERE menu_order_table < 100";
			
			$res = execute_db($sql, $conn);
		
			$row = fetch_row_db($res);
		
			$menu_order_table = $row[0];
			
			if (is_null($menu_order_table)){
			    $menu_order_table = 1;
			}
		
			// insert the table in dadabik_table_list, together with general permissions 
			$sql = "insert into ".$quote.$table_list_name.$quote." (".$quote."name_table".$quote.", ".$quote."allowed_table".$quote.", ".$quote."enable_insert_table".$quote.", ".$quote."enable_edit_table".$quote.", ".$quote."enable_delete_table".$quote.", ".$quote."enable_details_table".$quote.", ".$quote."enable_list_table".$quote.", ".$quote."alias_table".$quote.", pk_field_table, template_table, menu_order_table) values ('".$table_name_2."', '1', '".$enable_permissions_table."', '".$enable_permissions_table."', '".$enable_permissions_table."', '".$enable_permissions_table."', '".$enable_permissions_table."', '".$table_name_2."', '".$unique_field_name."', '', '".$menu_order_table."')";
		
			$res_insert = execute_db($sql, $conn);
		
			// delete info about the table fields (if the table is already existent) in the dadabik_forms tables
			$sql = "delete from ".$quote.$prefix_internal_table."forms".$quote." where ".$quote."table_name".$quote." = '".$table_name_2."'";
			$res_delete = execute_db($sql, $conn);
		
			// get the list of the fields with additional infos (such as type, NULLable, etc...) useful for the guessed settings later
			$add_additional_info = true;
			$fields_ar =get_fields_list($table_name_2, $add_additional_info);
		
			$filters_cnt = 0;
		
			for ($j=0; $j<count($fields_names_ar); $j++){
			
				// auto-configurator, guess the setting for the current field!
				$guessed_settings = guess_field_dadabik_settings($fields_ar, $j);
			
				// use the guess and some other info to add a record to the dadabik_forms table, related to the current field
				$label_field = $guessed_settings['label_field'];
				$type_field = $guessed_settings['type_field'];
				$content_field = $guessed_settings['content_field'];
				$maxlength_field = $guessed_settings['maxlength_field'];
				$primary_key_field_field = $guessed_settings['primary_key_field_field'];
				$linked_fields_field = $guessed_settings['linked_fields_field'];
				$primary_key_table_field = $guessed_settings['primary_key_table_field'];
				$select_options_field = $guessed_settings['select_options_field'];
				$select_type_field = $guessed_settings['search_operators_field'];
				$required_field = $guessed_settings['required_field'];
				
				if ($grant_permissions_autoincrement_after_table_installation === 1 || is_null($autoincrement_field) || $autoincrement_field !== $fields_names_ar[$j]){
                    $present_search_form_field = 1;
                    $present_results_search_field = 1;
                    $present_details_form_field = 1;
                    $present_insert_form_field = 1;
                    $present_edit_form_field = 1;
                    $present_ext_update_form_field = 1;
                    
                    if ($filters_cnt >= 2){
                        $present_filter_form_field = 0;
                    }
                    else{
                
                    }   $present_filter_form_field = 1;
                    
                }
                else{
                    $present_filter_form_field = 0;
                    $present_search_form_field = 0;
                    $present_results_search_field = 0;
                    $present_details_form_field = 0;
                    $present_insert_form_field = 0;
                    $present_edit_form_field = 0;
                    $present_ext_update_form_field = 0;
                }
                
                $filters_cnt++;
			
				// insert the table in dadabik_forms 
				$sql = "insert into ".$quote.$prefix_internal_table."forms".$quote." (".$quote."name_field".$quote.", ".$quote."label_field".$quote.", ".$quote."order_form_field".$quote.", ".$quote."table_name".$quote.", ".$quote."present_filter_form_field".$quote.", ".$quote."type_field".$quote.", ".$quote."content_field".$quote.", ".$quote."maxlength_field".$quote.", ".$quote."primary_key_field_field".$quote.", ".$quote."linked_fields_field".$quote.", ".$quote."primary_key_table_field".$quote.", ".$quote."select_options_field".$quote.", ".$quote."select_type_field".$quote.", ".$quote."required_field".$quote.", ".$quote."present_search_form_field".$quote.", ".$quote."present_results_search_field".$quote.", ".$quote."present_details_form_field".$quote.", ".$quote."present_insert_form_field".$quote.", ".$quote."present_edit_form_field".$quote.", ".$quote."present_ext_update_form_field".$quote.") values ('".$fields_names_ar[$j]."', '".$label_field."', '".($j+1)."', '".$table_name_2."', '".$present_filter_form_field."', '".$type_field."', '".$content_field."', '".$maxlength_field."', '".$primary_key_field_field."', '".$linked_fields_field."', '".$primary_key_table_field."', '".$select_options_field."', '".$select_type_field."', '".$required_field."', '".$present_search_form_field."', '".$present_results_search_field."', '".$present_details_form_field."', '".$present_insert_form_field."', '".$present_edit_form_field."', '".$present_ext_update_form_field."')";
			
				$res_insert = execute_db($sql, $conn);
				
				
				
			} // end for
		
			if ($grant_permissions_after_table_installation === 1){
			
				// grant all permissions to all groups 
				$groupd_ids = get_groups_list();
			}
			elseif ($grant_permissions_after_table_installation === 2){
		
				// grant all permissions to the admin group
				$groupd_ids = array();
				$groupd_ids[] = $id_admin_group;
			}
		
			if ($grant_permissions_after_table_installation === 1 || $grant_permissions_after_table_installation == 2){
				// insert granular permissions
				
				
		
				// for each group
				foreach ($groupd_ids as $id_group) {
		
					// grant table permissions
					for ($j=1; $j<=5; $j++){
						$sql = "INSERT INTO ".$quote.$prefix_internal_table."permissions".$quote."  (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) values ('group', '".$id_group."', 'table', '".escape($table_name_2)."', ".$j.", '1')";
						$res_insert = execute_db($sql, $conn);
					}
			
					// grant field permissions
					// for each field of the table
					for ($j=0; $j<count($fields_names_ar); $j++){
					
					    if ($grant_permissions_autoincrement_after_table_installation === 1 || is_null($autoincrement_field) || $autoincrement_field !== $fields_names_ar[$j]){
					
                            // for each permission type
                            for ($z=7; $z<=12; $z++){
            
                                if ($j < 2 || $z !== 11){ // just two filters, the first ones
                                    $value_permission_temp = 1;
                                }
                                else{
                                    $value_permission_temp = 0;
                                }
                    
                                $sql = "INSERT INTO ".$quote.$prefix_internal_table."permissions".$quote."  (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) values ('group', '".$id_group."', 'field', '".escape($table_name_2).".".escape($fields_names_ar[$j])."', ".$z.", '".$value_permission_temp."')";
                                $res_insert = execute_db($sql, $conn);
                        
                            }
                        }
				
					} // end for
			
				}
			}
		
		
			$confirmation_message .= "<b>Table/View ".$table_name_2." installed</b>.";
		
			if($grant_permissions_after_table_installation === 0){
				$confirmation_message .= " You should now set the <a href=\"permissions_manager.php?tablename=".urlencode($table_name_2)."\">permissions</a> before using it.";
			}
			else{
				if ($enable_granular_permissions === 1){
					if($grant_permissions_after_table_installation === 1){
						$confirmation_message .= " All <a href=\"permissions_manager.php?tablename=".urlencode($table_name_2)."\">permissions</a> have been granted to all groups.";
					}
					elseif($grant_permissions_after_table_installation === 2){
						$confirmation_message .= " All <a href=\"permissions_manager.php?tablename=".urlencode($table_name_2)."\">permissions</a> have been granted to the Admin group.";
					}	
				}
				else{	
					$confirmation_message .= " All <a href=\"permissions_manager.php?tablename=".urlencode($table_name_2)."\">permissions</a> have been granted.";
				}
			}

			if ($unique_field_name == ""){
				$alert_message .= "<b>".$table_name_2."</b> hasn't a unique field set, please set it manually otherwise DaDaBIK won't work correctly for this table/view.";
			} // end if
		
			// switch to views_installed or tables_installed to see the table/view just instealled
			if ($pages_to_show === 'views_not_installed'){
				$pages_to_show = 'views_installed';
			}
			elseif($pages_to_show === 'tables_not_installed'){
				$pages_to_show = 'tables_installed';
			}
			$_SESSION['pages_to_show'] = $pages_to_show;
		
			// re-get the array containing the names of the tables installed
			$installed_tables_ar = build_tables_names_array(0, 1, 1);
		
			/*
			// re-build the select with all installed table
			$change_table_select = build_change_table_select(0, 1);
			*/
		}
		
		complete_trans_db();



		break;
	case "uninstall_table":

		begin_trans_db();
	
		// delete the table from table_list_name
		$sql = "DELETE FROM ".$quote.$table_list_name.$quote." WHERE name_table = '".$table_name_2."'";
		execute_db($sql, $conn);
		
		// delete info about the table
		$sql = "delete from ".$quote.$prefix_internal_table."forms".$quote." where ".$quote."table_name".$quote." = '".$table_name_2."'";
		execute_db($sql, $conn);
		
		// delete permissions for the table
		$sql = "DELETE FROM ".$quote.$prefix_internal_table."permissions".$quote." WHERE object_type_permission = 'table' AND object_permission = '".$table_name_2."'";
		$res = execute_db($sql, $conn);
		
		// delete permissions for the fields
		$sql = "DELETE FROM ".$quote.$prefix_internal_table."permissions".$quote." WHERE object_type_permission = 'field' AND object_permission like '".$table_name_2.".%'";
		$res = execute_db($sql, $conn);
		
		complete_trans_db();
		
		$confirmation_message .= "Table/View ".$table_name_2." uninstalled.";

		// re-get the array containing the names of the tables installed
		$installed_tables_ar = build_tables_names_array(0, 1, 1);

		
		
		break;
		
	case "delete_page":

		if (isset($_GET['index_static_page_delete'])){
			$index_static_page_delete = (int)$_GET['index_static_page_delete'];
		}
		else{
			die('unexpected error');
		}

		// delete the custom page for dadabik_static_pages
		$sql = "DELETE FROM ".$quote.$prefix_internal_table.'static_pages'.$quote." WHERE id_static_page = :id_static_page";
		
		$res_prepare = prepare_db($conn, $sql);
		
		$values_to_bind = array();
		
		$values_to_bind['id_static_page'] = $static_pages_ar[$index_static_page_delete]['id_static_page'];
		
		foreach ($values_to_bind as $key => $value)
		{
			$res_bind = bind_param_db($res_prepare, ':'.$key, $value);
		}
		
		$res = execute_prepared_db($res_prepare,0);
		
		$confirmation_message .= "Page ".$static_pages_ar[$index_static_page_delete]['link_static_page']." uninstalled.";

		// re-get the array containing the names of the static pages
		$static_pages_ar = build_static_pages_ar();

		
		
		break;
	case "add_page":

		// add a new untitled custom page to dadabik_static_pages
		$sql = "INSERT INTO ".$quote.$prefix_internal_table.'static_pages'.$quote." (link_static_page, type_static_page, file_static_page, content_static_page, is_homepage_static_page, menu_parent_page, href_link_static_page) VALUES ('Untitled', 'html', '', 'Draft content', 'n', 'top', '')";
		
		$res = execute_db($sql, $conn);
		
		$confirmation_message .= "Page added.";

		// re-get the array containing the names of the static pages
		$static_pages_ar = build_static_pages_ar();
		
		break;
	default:
		break;
} // end switch
?>

<span id="confirmation_message_container">
<?php
if ($confirmation_message != ""){
	echo '<div class="msg_ok" id="confirmation_message"><p>'.$confirmation_message.'<br/><br/><a href="javascript:{}" id="confirmation_message_close_link">Ok, close</a></p></div>';
} // end if
if ($error_message != ""){
	echo '<div class="msg_error" id="error_message"><p>'.$error_message.'<br/><br/><a href="javascript:{}" id="error_message_close_link">Ok, close</a></p></div>';
} // end if
if ($alert_message != ""){
	echo '<div class="msg_alert" id="alert_message"><p>'.$alert_message.'<br/><br/><a href="javascript:{}" id="alert_message_close_link">Ok, close</a></p></div>';
} // end if


?>
</span>

<table>
<tr><td valign="top">

<p><font size="+1">Manage the pages of your DaDaBIK application</font></p>

<p>You have pages based on Tables, pages based on Views and custom pages. Pages based on tables and views need to be <strong>installed</strong> in order to be used: when you <strong>install</strong> a new table or view in DaDaBIK, a default page containing a standard report and forms for the table/view is automatically created.</p>

<p>DaDaBIK needs a <strong>unique field</strong> for each table and view used here; for <strong>tables</strong>, during the installation the Primary Key of the table is automatically chosen, for <b>views</b> you have to set it manually from this page.</p>


<p><a href="javascript:{}" id="craete_new_view_link">Show/Hide create view form</a></p>

<div id="create_new_view_form" style="display:none">
<form method="POST" action="tables_inclusion.php?function=create_view">
<p>CREATE VIEW <input type="text" name="name_view" placeholder="Name of the View"
<?php
if (isset($_POST['name_view']) && $_POST['name_view'] !== ''){
echo ' value="'.($_POST['name_view']).'"';
}
?>
> AS <br/> <br/>
<textarea rows="5" cols="100" name="sql_create_view" placeholder="Type here the SQL SELECT for the View, for example: SELECT first_name_customer AS first_name, last_name_customer AS last_name FROM customers WHERE id_customer > 10">
<?php
if (isset($_POST['sql_create_view']) && $_POST['sql_create_view'] !== '' ){
	echo unescape($_POST['sql_create_view']);
}
?>
</textarea>
</p>

 
<input class="button_admin" type="submit" value="Create View">
</form>
</div>

<p><form name="change_pages_to_show_form" action="tables_inclusion.php" method="GET">Show: 
<select name="pages_to_show" onchange="javascript:document.change_pages_to_show_form.submit()">
<option value="tables_installed" <?php if ($pages_to_show === 'tables_installed') echo ' selected'; ?>>Pages based on Tables</option>
<option value="views_installed"<?php if ($pages_to_show === 'views_installed') echo ' selected'; ?>>Pages based on Views</option>
<option value="tables_not_installed"<?php if ($pages_to_show === 'tables_not_installed') echo ' selected'; ?>>Other not installed Tables</option>
<option value="views_not_installed"<?php if ($pages_to_show === 'views_not_installed') echo ' selected'; ?>>Other not installed Views</option>
<option value="custom_pages"<?php if ($pages_to_show === 'custom_pages') echo ' selected'; ?>>Custom Pages</option>
</select>
</form>

<form id="include_tables_form" method="post" action="tables_inclusion.php">

<?php
if ($pages_to_show === 'tables_installed'){

	// Check if there is any item in this category
	$index = 0;
	for ($i=0; $i<count($complete_tables_names_ar); $i++){
		if ($complete_tables_types_ar[$i] === 'table' && in_array($complete_tables_names_ar[$i], $installed_tables_ar) ){
			$index++;
		}
	} // end for
	
	if ($index === 0){
		echo '<p>There isn\'t any item in this category</p>';
	}
	else{ // there are pages based on tables installed so print out the info 
?>

		<h1>Pages based on tables</h1>
		<input class="button_admin" type="submit" value="SAVE CHANGES"><br/><br/>
		<table cellpadding="3">
		<tr>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Page name</th>
		<th nowrap style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Table name</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Installed</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Enabled</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Unique field</th>
		<th nowrap style="text-align:left;padding: 0 60px 0 0">Menu<br/>Order / Separator <a href="javascript:show_admin_help('Show separator before', 'Check if you want to show a line separator before this item in the menu.');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a> / Parent <a href="javascript:show_admin_help('Parent container', 'Specify here the name of a parent container or leave <b>top</b> if you want to show this item at the top level.');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a></th>
		</tr>

		<?php
		$index = 0;
		// for each table installed print the corresponding row
		for ($i=0; $i<count($complete_tables_names_ar); $i++){
			if ($complete_tables_types_ar[$i] === 'table' && in_array($complete_tables_names_ar[$i], $installed_tables_ar) ){
				$index++;
				$installed = 1;
				print_table_row($complete_tables_names_ar, $i, $index, $installed_tables_ar, $table_name, $installed, $static_pages_ar);
			}
		} // end for
		?>
		</table><br/><input class="button_admin" type="submit" value="SAVE CHANGES">
		

<?php
	} // end else
} // end if ($pages_to_show === 'tables_installed'){

if ($pages_to_show === 'views_installed'){

	$index = 0;
	for ($i=0; $i<count($complete_tables_names_ar); $i++){
		if ($complete_tables_types_ar[$i] === 'view' && in_array($complete_tables_names_ar[$i], $installed_tables_ar) ){
			$index++;
		}
	} // end for
	
	if ($index === 0){
		echo '<p>There isn\'t any item in this category</p>';
	}
	else{
	?>

		<h1>Pages based on Views</h1>
		<input class="button_admin" type="submit" value="SAVE CHANGES"><br/><br/>
		<table cellpadding="3">
		<tr>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Page name</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">View name</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Installed</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Enabled</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Unique field</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 80px 0 0">Menu<br/>Order / Separator <a href="javascript:show_admin_help('Show separator before', 'Check if you want to show a line separator before this item in the menu.');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a> / Parent <a href="javascript:show_admin_help('Parent container', 'Specify here the name of a parent container or leave <b>top</b> if you want to show this item at the top level.');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a></th>
		</tr>

		<?php
		$index = 0;
		for ($i=0; $i<count($complete_tables_names_ar); $i++){
			if ($complete_tables_types_ar[$i] === 'view' && in_array($complete_tables_names_ar[$i], $installed_tables_ar) ){
				$index++;
				$installed = 1;
				print_table_row($complete_tables_names_ar, $i, $index, $installed_tables_ar, $table_name, $installed, $static_pages_ar);
			}
		} // end for
		?>
		</table><br/><input class="button_admin" type="submit" value="SAVE CHANGES">

	<?php
	} // end else
} // end if( $pages_to_show === 'views_installed'){


if ($pages_to_show === 'tables_not_installed'){
	
	$index = 0;
	for ($i=0; $i<count($complete_tables_names_ar); $i++){
		if ($complete_tables_types_ar[$i] === 'table' && !in_array($complete_tables_names_ar[$i], $installed_tables_ar) ){
			$index++;
		}
	} // end for
	
	if ($index === 0){
		echo '<p>There isn\'t any item in this category</p>';
	}
	else{
	?>

		<h1>Other not installed tables </h1>
		<table cellpadding="3">
		<tr>

		<th style="text-align:left;padding: 0 80px 0 0">Table name</th>
		<th style="text-align:left;padding: 0 80px 0 0">Installed</th>
		</tr>

		<?php
		$index = 0;
		for ($i=0; $i<count($complete_tables_names_ar); $i++){
			if ($complete_tables_types_ar[$i] === 'table' && !in_array($complete_tables_names_ar[$i], $installed_tables_ar) ){
				$installed = 0;
				$index++;
				print_table_row($complete_tables_names_ar, $i, $index, $installed_tables_ar, $table_name, $installed, $static_pages_ar);
			}
		} // end for
		?>
		</table>

	<?php
	} // end else
} // end if ($pages_to_show === 'tables_not_installed'){ 
?>

<?php
if ($pages_to_show === 'views_not_installed'){

	$index = 0;
	for ($i=0; $i<count($complete_tables_names_ar); $i++){
		if ($complete_tables_types_ar[$i] === 'view' && !in_array($complete_tables_names_ar[$i], $installed_tables_ar) ){
			$index++;
		}
	} // end for
	
	if ($index === 0){
		echo '<p>There isn\'t any item in this category</p>';
	}
	else{
	?>

		<h1>Other not installed views </h1>
		<table cellpadding="3">
		<tr>

		<th style="text-align:left;padding: 0 80px 0 0">View name</th>
		<th style="text-align:left;padding: 0 80px 0 0">Installed</th>
		</tr>

		<?php
		$index = 0;
		for ($i=0; $i<count($complete_tables_names_ar); $i++){
			if ($complete_tables_types_ar[$i] === 'view' && !in_array($complete_tables_names_ar[$i], $installed_tables_ar) ){
				$installed = 0;
				$index++;
				print_table_row($complete_tables_names_ar, $i, $index, $installed_tables_ar, $table_name, $installed, $static_pages_ar);
			}
		} // end for
		?>
		</table>

	<?php
	} // end else	
} // end if ($pages_to_show === 'views_not_installed'){

if ($pages_to_show === 'custom_pages'){

	
	if (count($static_pages_ar) === 0){
		echo '<p>There isn\'t any item in this category <input id="add_page" onclick="location.href=\'tables_inclusion.php?function=add_page\';" class="button_admin" type="button" value="ADD PAGE"></p>';
	}
	else{
	?>

		<h1>Custom Pages</h1>
		<input class="button_admin" type="submit" value="SAVE CHANGES">&nbsp;&nbsp;<input id="add_page" onclick="location.href='tables_inclusion.php?function=add_page';" class="button_admin" type="button" value="ADD PAGE"><br/><br/>
		<table cellpadding="3">
		<tr>
		<th></th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 00px 0 0">Page name</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 10px 0 0">Enabled</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 20px 0 0">Type <a href="javascript:show_admin_help('Type', '<b>HTML</b> is an HTML page, you can specify the content by clicking on <i>show/hide html content</i><br/><br/><b>PHP</b> is a PHP page, you also have to specify the PHP source file<br/><br/><b>int. link</b> and <b>ext. link</b> allow you to specify a simple link, internal to the application (e.g. a link to a graph report) or external (e.g. http://www.wikipedia.org), in both cases you have to specify the URL in <i>HREF link</i>.<br>It can be particularly useful to link a graph report (just paste the URL of the resulting page, see the documentation for futher details).');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a></th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 10px 0 0;white-space: nowrap;">PHP source file <a href="javascript:show_admin_help('PHP source file', 'You have to create the file containing the PHP code in the following folder: <br/><strong>/include/custom_php_files</strong><br/><br/>Once you create the file, it will appear in the dropdown menu here.');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a></th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 20px 0 0;white-space: nowrap;">Href link</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 20px 0 0;white-space: nowrap;">HTML content</th>
		<th style="text-align:left;vertical-align:bottom;padding: 0 20px 0 0">Home</th>
		
		<th nowrap style="text-align:left;vertical-align:bottom;padding: 0 00 0 0">Menu<br/>Order / Separator <a href="javascript:show_admin_help('Show separator before', 'Check if you want to show a line separator before this item in the menu.');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a> / Parent <a href="javascript:show_admin_help('Parent container', 'Specify here the name of a parent container or leave <b>top</b> if you want to show this item at the top level.');"><img alt="Help" title="Help" border="0" src="images/help.png" /></a></th>
		</tr>

		<?php
		$index = 0;
		for ($i=0; $i<count($static_pages_ar); $i++){
			$index++;
			print_page_row($index, $static_pages_ar, $installed_tables_ar);
		} // end for
		
		?>
		</table><br/><input class="button_admin" type="submit" value="SAVE CHANGES">

	<?php
	} // end else
} // end if ($pages_to_show === 'custom_pages'){

?>

<input type="hidden" id="number_items" name="number_items" value="<?php echo $index; ?>">
<input type="hidden" id="pages_to_show" name="pages_to_show" value="<?php echo $pages_to_show; ?>">


</form>
</td></tr></table>



<?php
// include footer
include ("./include/footer.php");
?>
