<?php
/*
***********************************************************************************
DaDaBIK (DaDaBIK is a DataBase Interfaces Kreator) https://dadabik.com/
Copyright (C) 2001-2017  Eugenio Tacchini

This program is distributed "as is" and WITHOUT ANY WARRANTY, either expressed or implied, without even the implied warranties of merchantability or fitness for a particular purpose.

This program is distributed under the terms of the DaDaBIK license, which is included in this package (see dadabik_license.txt). For all the details see dadabik_license.txt.

If you are unsure about what you are allowed to do with this license, feel free to contact eugenio.tacchini@gmail.com
***********************************************************************************
*/
?>
<?php

// include config, functions, common and header
include ("./include/config.php");

$temp = file_get_contents('version_first_installation');
$temp = explode(' ', $temp);
$dadabik_version = $temp[0];
$dadabik_edition = $temp[1];

if ($db_library === 'adodb'){
	include('./include/adodb'.DADABIK_ADODB_VERSION.'/adodb.inc.php');
	
	// hack for oracle, all field names fetched in lower case
	if ($dbms_type === 'oci8po') {
		define('ADODB_ASSOC_CASE', 0); 
	} // end if
}
include ("./include/functions.php");
include ("./include/common_start.php");

$page_name = 'upgrade';

//include ("./include/check_installation.php");
if ( !table_exists($table_list_name) ){ // if the $table_list_name table doesn't exist it means that DaDaBIK has not been installed
	echo "<p><b>[03] Error:</b> it is impossible to run DaDaBIK because you haven't installed it yet or you have accidentally deleted the installation table, go to the <a href=\"install.php\">installation</a> page.";
	exit;
} // end
require ('./include/PasswordHash.php');

include ("./include/header_install.php");

// variables:

if (isset($_POST["upgrade"])){
	$upgrade = (int)$_POST["upgrade"];
} // end if
else{
	$upgrade = "";
} // end else

echo '<div class="container_install_text">';

if ($upgrade === 1){

	if ($dbms_type === 'sqlite'){	
		echo '<p>Due to SQLite limitations, the upgrade is available just for MySQL and PostgreSQL.</p>';
	}
	else{
	
		begin_trans_db();

		$temp_ar = get_current_version(1);
		
		$temp_ar_2 = explode(',', $temp_ar);
		
		$current_version = $temp_ar_2[0];
		$current_version_2 = $temp_ar_2[2];
		
		
		
		if ($current_version <= '5.0'){
			echo '<p>Your current version is prior to 5.0, it is not possible to upgrade it using this procedure. You have to <a href="install.php">install</a> DaDaBIK from scratch.</p>';
		}
		else{
			switch ($current_version){
				case '5.0':
					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."users".$quote." ADD authentication_type_user VARCHAR( 255 ) NOT NULL DEFAULT  'dadabik'";
				
					$res = execute_db($sql, $conn);
				case '5.1':	
				case '5.1.1':	
					$date_time = date("Y-m-d H:i:s");
				
				
					if ($dbms_type === 'mysql'){
					
						$sql = "ALTER TABLE ".$quote.$prefix_internal_table."users".$quote." CHANGE authentication_type_user authentication_type_user VARCHAR( 255 ) NOT NULL DEFAULT  'dadabik'";
					}
					else{
						$sql = "ALTER TABLE ".$quote.$prefix_internal_table."users".$quote." alter column authentication_type_user set default 'dadabik'";
					}
				
					$res = execute_db($sql, $conn);
				
					$sql = "update ".$quote.$prefix_internal_table."users".$quote." set authentication_type_user = 'dadabik' where  authentication_type_user = ''";
				
					$res = execute_db($sql, $conn);
				
					$sql = "update ".$quote.$prefix_internal_table."permissions".$quote." set value_permission = 0 where object_permission = '".$prefix_internal_table."users.authentication_type_user' and (id_permission_type = 8 or id_permission_type = 9) ";
				
					$res = execute_db($sql, $conn);
				case '5.1.2':
			
					$sql = "select count(*) from ".$quote.$prefix_internal_table."permission_options".$quote." where value_permission_option = 3";
				
					$res = execute_db($sql, $conn);
				
					$row = fetch_row_db($res);
				
					if ($row[0] == 0){ // old versions will use the create function and already have
				
						$sql = "INSERT INTO  ".$quote.$prefix_internal_table."permission_options".$quote." (label_permission_option ,value_permission_option) VALUES ('Yes but disabled',  '3')";
					
						$res = execute_db($sql, $conn);
					}
				
					$sql = "UPDATE ".$quote.$prefix_internal_table."permission_types".$quote." SET  options_permission_type =  '0,1,3' WHERE id_permission_type =8";
				
					$res = execute_db($sql, $conn);
				
					$sql = "UPDATE ".$quote.$table_list_name.$quote." SET  alias_table =  'Custom pages' WHERE  name_table =  '".$prefix_internal_table."static_pages'";
				
					$res = execute_db($sql, $conn);
				
					$fields_ar_temp = get_fields_list($prefix_internal_table."permission_options");
				
					if (!in_array('type_static_page', $fields_ar_temp)){ // otherwise it means it's an old version and have been added by the create function
				
						$sql = "ALTER TABLE  ".$quote.$prefix_internal_table."static_pages".$quote." ADD  type_static_page VARCHAR( 10 ) NOT NULL default '', ADD  file_static_page VARCHAR( 50 ) NOT NULL default ''";
					
						$res = execute_db($sql, $conn);
					}
				
					$sql = "update  ".$quote.$prefix_internal_table."static_pages".$quote." set type_static_page = 'html'";
				
					$res = execute_db($sql, $conn);
				
					$sql = "UPDATE ".$quote.$prefix_internal_table."forms".$quote." set ".$quote."order_form_field".$quote." = 6 where ".$quote."order_form_field".$quote." = 4 and ".$quote."table_name".$quote." = '".$prefix_internal_table."static_pages'";
				
					$res = execute_db($sql, $conn);
				
					$sql = "UPDATE ".$quote.$prefix_internal_table."forms".$quote." set ".$quote."required_field".$quote." = 0, ".$quote."order_form_field".$quote." = 5 where ".$quote."order_form_field".$quote." = 3 and ".$quote."table_name".$quote." = '".$prefix_internal_table."static_pages'";
				
					$res = execute_db($sql, $conn);
				
					$sql = "UPDATE ".$quote.$prefix_internal_table."forms".$quote." set ".$quote."check_duplicated_insert_field".$quote." = 0 where ".$quote."name_field".$quote." = 'is_homepage_static_page' and ".$quote."table_name".$quote." = '".$prefix_internal_table."static_pages'";
				
					$res = execute_db($sql, $conn);
				
				
					$sql = "INSERT INTO ".$quote.$prefix_internal_table."forms".$quote." (".$quote."name_field".$quote.", ".$quote."label_field".$quote.", ".$quote."type_field".$quote.", ".$quote."content_field".$quote.", ".$quote."present_search_form_field".$quote.", ".$quote."present_results_search_field".$quote.", ".$quote."present_details_form_field".$quote.", ".$quote."present_insert_form_field".$quote.", ".$quote."present_edit_form_field".$quote.", ".$quote."present_ext_update_form_field".$quote.", ".$quote."required_field".$quote.", ".$quote."check_duplicated_insert_field".$quote.", ".$quote."other_choices_field".$quote.", ".$quote."select_options_field".$quote.", ".$quote."primary_key_field_field".$quote.", ".$quote."primary_key_table_field".$quote.", ".$quote."primary_key_db_field".$quote.", ".$quote."linked_fields_field".$quote.", ".$quote."linked_fields_order_by_field".$quote.", ".$quote."linked_fields_order_type_field".$quote.", ".$quote."select_type_field".$quote.", ".$quote."items_table_names_field".$quote.", ".$quote."items_table_fk_field_names_field".$quote.", ".$quote."prefix_field".$quote.", ".$quote."default_value_field".$quote.", ".$quote."width_field".$quote.", ".$quote."height_field".$quote.", ".$quote."maxlength_field".$quote.", ".$quote."hint_insert_field".$quote.", ".$quote."order_form_field".$quote.", ".$quote."separator_field".$quote.", ".$quote."table_name".$quote.", ".$quote."present_filter_form_field".$quote.") VALUES ('type_static_page', 'Type', 'select_single', 'alphanumeric', '1', '1', '1', '1', '1', '1', '1', '1', '0', '~html~PHP~', '', '', '', '', '', '', 'is_equal/is_different/contains/starts_with/ends_with/greater_than/less_then/is_null/is_not_null/is_empty/is_not_empty', '', '', '', '', '', '', '100', '";

					$sql .= "The PHP type works just with DaDaBIK ENTERPRISE";


				
					$sql .= "', 3, '~', '".$prefix_internal_table."static_pages', '1')";
				
					$res = execute_db($sql, $conn);
				
					$sql = "INSERT INTO ".$quote.$prefix_internal_table."forms".$quote." (".$quote."name_field".$quote.", ".$quote."label_field".$quote.", ".$quote."type_field".$quote.", ".$quote."content_field".$quote.", ".$quote."present_search_form_field".$quote.", ".$quote."present_results_search_field".$quote.", ".$quote."present_details_form_field".$quote.", ".$quote."present_insert_form_field".$quote.", ".$quote."present_edit_form_field".$quote.", ".$quote."present_ext_update_form_field".$quote.", ".$quote."required_field".$quote.", ".$quote."check_duplicated_insert_field".$quote.", ".$quote."other_choices_field".$quote.", ".$quote."select_options_field".$quote.", ".$quote."primary_key_field_field".$quote.", ".$quote."primary_key_table_field".$quote.", ".$quote."primary_key_db_field".$quote.", ".$quote."linked_fields_field".$quote.", ".$quote."linked_fields_order_by_field".$quote.", ".$quote."linked_fields_order_type_field".$quote.", ".$quote."select_type_field".$quote.", ".$quote."items_table_names_field".$quote.", ".$quote."items_table_fk_field_names_field".$quote.", ".$quote."prefix_field".$quote.", ".$quote."default_value_field".$quote.", ".$quote."width_field".$quote.", ".$quote."height_field".$quote.", ".$quote."maxlength_field".$quote.", ".$quote."hint_insert_field".$quote.", ".$quote."order_form_field".$quote.", ".$quote."separator_field".$quote.", ".$quote."table_name".$quote.", ".$quote."present_filter_form_field".$quote.") VALUES ('file_static_page', 'PHP source file', 'text', 'alphanumeric', '1', '1', '1', '1', '1', '1', '0', '1', '0', '', '', '', '', '', '', '', 'is_equal/is_different/contains/starts_with/ends_with/greater_than/less_then/is_null/is_not_null/is_empty/is_not_empty', '', '', '', '', '', '', '100', 'For PHP custom pages, fill this field and leave <i>content</i> empty.<br/>&nbsp;&nbsp;The extension .php will be added automatically (e.g. for test.php just write test).<br/>&nbsp;&nbsp;Files need to be created in the folder /include/custom_php_files<br/>&nbsp;&nbsp;Open /include/custom_php_files/example.php for instructions.', 4, '~', '".$prefix_internal_table."static_pages', '1')";
				
					$res = execute_db($sql, $conn);
				
					$table_name_temp = $prefix_internal_table.'static_pages';
			
					$fields_names_temp_ar[0] = 'type_static_page';
					$fields_names_temp_ar[1] = 'file_static_page';
				
				
					for ($j=0; $j<count($fields_names_temp_ar); $j++){
				
						for ($z=7; $z<=12; $z++){
					
							if ($z !== 11){ // no filter
								$sql = "INSERT INTO ".$quote.$prefix_internal_table."permissions".$quote."  (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) values ('group', 1, 'field', '".escape($table_name_temp).".".escape($fields_names_temp_ar[$j])."', ".$z.", '1')";
							
								$res = execute_db($sql, $conn);
						
								$sql = "INSERT INTO ".$quote.$prefix_internal_table."permissions".$quote."  (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) values ('user', 1, 'field', '".escape($table_name_temp).".".escape($fields_names_temp_ar[$j])."', ".$z.", '1')";
							
								$res = execute_db($sql, $conn);
							}
							else{
								$sql = "INSERT INTO ".$quote.$prefix_internal_table."permissions".$quote."  (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) values ('group', 1, 'field', '".escape($table_name_temp).".".escape($fields_names_temp_ar[$j])."', ".$z.", '0')";
							
								$res = execute_db($sql, $conn);
						
								$sql = "INSERT INTO ".$quote.$prefix_internal_table."permissions".$quote."  (subject_type_permission,id_subject,object_type_permission,object_permission,id_permission_type,value_permission) values ('user', 1, 'field', '".escape($table_name_temp).".".escape($fields_names_temp_ar[$j])."', ".$z.", '0')";
							
								$res = execute_db($sql, $conn);
							}
								
						}
					}
				
				case '6.0': 	
					$table_name_temp = $prefix_internal_table."static_pages";
				
					/*
					if ($current_version_2 === 'PRO'){
					
						$sql = "INSERT INTO ".$quote.$prefix_internal_table."forms".$quote." (".$quote."name_field".$quote.", ".$quote."label_field".$quote.", ".$quote."type_field".$quote.", ".$quote."content_field".$quote.", ".$quote."present_search_form_field".$quote.", ".$quote."present_results_search_field".$quote.", ".$quote."present_details_form_field".$quote.", ".$quote."present_insert_form_field".$quote.", ".$quote."present_edit_form_field".$quote.", ".$quote."present_ext_update_form_field".$quote.", ".$quote."required_field".$quote.", ".$quote."check_duplicated_insert_field".$quote.", ".$quote."other_choices_field".$quote.", ".$quote."select_options_field".$quote.", ".$quote."primary_key_field_field".$quote.", ".$quote."primary_key_table_field".$quote.", ".$quote."primary_key_db_field".$quote.", ".$quote."linked_fields_field".$quote.", ".$quote."linked_fields_order_by_field".$quote.", ".$quote."linked_fields_order_type_field".$quote.", ".$quote."select_type_field".$quote.", ".$quote."items_table_names_field".$quote.", ".$quote."items_table_fk_field_names_field".$quote.", ".$quote."prefix_field".$quote.", ".$quote."default_value_field".$quote.", ".$quote."width_field".$quote.", ".$quote."height_field".$quote.", ".$quote."maxlength_field".$quote.", ".$quote."hint_insert_field".$quote.", ".$quote."order_form_field".$quote.", ".$quote."separator_field".$quote.", ".$quote."table_name".$quote.", ".$quote."present_filter_form_field".$quote.") VALUES ('type_static_page', 'Type', 'select_single', 'alphanumeric', '1', '1', '1', '1', '1', '1', '1', '0', '0', '~html~PHP~', '', '', '', '', '', '', 'is_equal/is_different/contains/starts_with/ends_with/greater_than/less_then/is_null/is_not_null/is_empty/is_not_empty', '', '', '', '', '', '', '100', '', 3, '~', '".$table_name_temp."', '1')";
				
						$res_insert = execute_db($sql, $conn);
					
						$sql = "INSERT INTO ".$quote.$prefix_internal_table."forms".$quote." (".$quote."name_field".$quote.", ".$quote."label_field".$quote.", ".$quote."type_field".$quote.", ".$quote."content_field".$quote.", ".$quote."present_search_form_field".$quote.", ".$quote."present_results_search_field".$quote.", ".$quote."present_details_form_field".$quote.", ".$quote."present_insert_form_field".$quote.", ".$quote."present_edit_form_field".$quote.", ".$quote."present_ext_update_form_field".$quote.", ".$quote."required_field".$quote.", ".$quote."check_duplicated_insert_field".$quote.", ".$quote."other_choices_field".$quote.", ".$quote."select_options_field".$quote.", ".$quote."primary_key_field_field".$quote.", ".$quote."primary_key_table_field".$quote.", ".$quote."primary_key_db_field".$quote.", ".$quote."linked_fields_field".$quote.", ".$quote."linked_fields_order_by_field".$quote.", ".$quote."linked_fields_order_type_field".$quote.", ".$quote."select_type_field".$quote.", ".$quote."items_table_names_field".$quote.", ".$quote."items_table_fk_field_names_field".$quote.", ".$quote."prefix_field".$quote.", ".$quote."default_value_field".$quote.", ".$quote."width_field".$quote.", ".$quote."height_field".$quote.", ".$quote."maxlength_field".$quote.", ".$quote."hint_insert_field".$quote.", ".$quote."order_form_field".$quote.", ".$quote."separator_field".$quote.", ".$quote."table_name".$quote.", ".$quote."present_filter_form_field".$quote.") VALUES ('file_static_page', 'PHP source file', 'text', 'alphanumeric', '1', '1', '1', '1', '1', '1', '0', '1', '0', '', '', '', '', '', '', '', 'is_equal/is_different/contains/starts_with/ends_with/greater_than/less_then/is_null/is_not_null/is_empty/is_not_empty', '', '', '', '', '', '', '100', 'For PHP custom pages, fill this field and leave <i>content</i> empty.<br/>&nbsp;&nbsp;The extension .php will be added automatically (e.g. for test.php just write test).<br/>&nbsp;&nbsp;Files need to be created in the folder /include/custom_php_files<br/>&nbsp;&nbsp;Open /include/custom_php_files/example.php for instructions.', 4, '~', '".$table_name_temp."', '1')";
					
						$res_insert = execute_db($sql, $conn);
					
						$sql = "UPDATE ".$table_name_temp." SET type_static_page = 'html'";
					
						$res_insert = execute_db($sql, $conn);
					}
				
					*/
				
					$sql = "update ".$quote.$prefix_internal_table."users".$quote." set authentication_type_user = 'dadabik' where  authentication_type_user = ''";
				
					$res = execute_db($sql, $conn);
				
					$sql = "update ".$quote.$prefix_internal_table."permissions".$quote." set value_permission = 0 where object_permission = '".$prefix_internal_table."users.authentication_type_user' and (id_permission_type = 8 or id_permission_type = 9) ";
				
					$res = execute_db($sql, $conn);
				
				case '6.1':
				case '6.2':
				
			
				
					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."logs".$quote." ADD username_user VARCHAR( 255 ) NULL";
					$res = execute_db($sql, $conn);
				
				
				
					if ($dbms_type === 'mysql'){
				
						$sql = "ALTER TABLE  ".$quote.$prefix_internal_table."forms".$quote."  CHANGE  name_field name_field VARCHAR( 255 )";
						$res = execute_db($sql, $conn);
					}
					else{
						$sql = "ALTER TABLE ".$quote.$prefix_internal_table."forms".$quote." alter column name_field type VARCHAR( 255 )";
						$res = execute_db($sql, $conn);
					}
				
					create_failed_login_table();
			
				case '6.3':
				
				
					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."forms".$quote." ADD custom_required_function_field VARCHAR( 500 ) NOT NULL DEFAULT ''";
					$res = execute_db($sql, $conn);
				
				
					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."forms".$quote." ADD cascade_filter_field VARCHAR(500) NOT NULL DEFAULT '' , ADD ".$quote."cascade_parent_field".$quote." VARCHAR(500) NOT NULL DEFAULT ''";
					$res = execute_db($sql, $conn);
				
				case '7.0':
				case '7.1':
			
					create_unique_ids_table();
				
				
				case '7.2':
				case '7.3':
				case '7.3.1':
				case '7.3.2':
				case '7.3.3':
					$sql = "update ".$quote.$prefix_internal_table."forms".$quote." set type_field = 'update_date_time' where type_field = 'update_date'";
					$res = execute_db($sql, $conn);

					$sql = "update ".$quote.$prefix_internal_table."forms".$quote." set type_field = 'insert_date_time' where type_field = 'insert_date'";
					$res = execute_db($sql, $conn);
					
					$sql = "ALTER TABLE ".$quote.$table_list_name.$quote."  ADD menu_parent_table VARCHAR(255) NOT NULL DEFAULT 'top';";
					$res = execute_db($sql, $conn);

					$sql = "ALTER TABLE ".$quote.$table_list_name.$quote." ADD separator_before_table CHAR(1) NOT NULL DEFAULT 'n';";
					$res = execute_db($sql, $conn);

					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."static_pages".$quote." ADD separator_before_static_page CHAR(1) NOT NULL DEFAULT 'n' ";
					$res = execute_db($sql, $conn);

					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."forms".$quote." ADD show_lookup_link_field VARCHAR(1) NOT NULL DEFAULT '0' ";
					$res = execute_db($sql, $conn);

					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."static_pages".$quote." ADD href_link_static_page TEXT NOT NULL ";
					if ($dbms_type !== 'mysql'){
						$sql .= " default ''";
					}
					$res = execute_db($sql, $conn);

					$sql = "ALTER TABLE ".$quote.$table_list_name.$quote." ADD menu_order_table INT NOT NULL DEFAULT '1' ;";
					$res = execute_db($sql, $conn);

					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."static_pages".$quote." ADD menu_order_static_page INT NOT NULL DEFAULT '1';";
					$res = execute_db($sql, $conn);

					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."forms".$quote." ADD calculated_function_field VARCHAR(500) DEFAULT '' NOT NULL ";
					$res = execute_db($sql, $conn);

					if ($dbms_type !== 'postgres'){
					$sql = "ALTER TABLE ".$quote.$table_list_name.$quote." ADD PRIMARY KEY(name_table);";
					$res = execute_db($sql, $conn);
					}

					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."static_pages".$quote." ADD menu_parent_page VARCHAR(500) NOT NULL DEFAULT 'top' ";
					$res = execute_db($sql, $conn);

					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."static_pages".$quote." ADD enabled_static_page INT NOT NULL DEFAULT '0' ";
					$res = execute_db($sql, $conn);

					$sql = "UPDATE ".$quote.$prefix_internal_table."static_pages".$quote." SET enabled_static_page = 1;";
					$res = execute_db($sql, $conn);

					$sql = "delete from ".$quote.$table_list_name.$quote." where name_table = '".$prefix_internal_table."static_pages'";
					$res = execute_db($sql, $conn);

					$sql = "delete  FROM ".$quote.$prefix_internal_table."forms".$quote." WHERE table_name = '".$prefix_internal_table."static_pages'";
					$res = execute_db($sql, $conn);

					$sql = "delete FROM ".$quote.$prefix_internal_table."permissions".$quote." WHERE object_permission = '".$prefix_internal_table."static_pages"."' or object_permission like '".$prefix_internal_table."static_pages".".%'";
					$res = execute_db($sql, $conn);
					
				case '8.0-beta':
					
					$sql = "ALTER TABLE ".$quote.$prefix_internal_table."forms".$quote."  ADD min_width_results_grid_column_field VARCHAR(50) NOT NULL default ''";
					
					$res = execute_db($sql, $conn);
					
					$sql = "UPDATE ".$quote.$prefix_internal_table."forms".$quote." SET hint_insert_field = '".escape('<a href="javascript:void(generic_js_popup(\'pwd.php\',\'\',600,500))">crypter (click here first)</a>')."' WHERE hint_insert_field = '".escape('<a href="javascript:void(generic_js_popup(\'pwd.php\',\'\',600,300))">crypter (click here first)</a>')."' ";
					$res = execute_db($sql, $conn);
					
				case '8.0-beta-2':
					$sql = "UPDATE ".$quote.$table_list_name.$quote." set menu_order_table = 1000, menu_parent_table = 'Admin' WHERE name_table = '".$users_table_name."'";
					$res = execute_db($sql, $conn);
					
					$sql = "UPDATE ".$quote.$table_list_name.$quote." set menu_order_table = 1001, menu_parent_table = 'Admin' WHERE name_table = '".$groups_table_name."'";
					$res = execute_db($sql, $conn);
					
					
				case '8.0-Lerici':
				    
				    $sql = "ALTER TABLE ".$quote.$prefix_internal_table."forms".$quote." ADD chosen_field VARCHAR(1) NOT NULL DEFAULT '0'";
					$res = execute_db($sql, $conn);
					
					
				    if ($dbms_type === 'mysql'){
				
						$sql = "ALTER TABLE  ".$quote.$table_list_name.$quote." CHANGE  name_table name_table VARCHAR( 128 ) NOT NULL DEFAULT ''";
						$res = execute_db($sql, $conn);
					}
					else{
					    $sql = "ALTER TABLE  ".$quote.$table_list_name.$quote." alter column name_table type VARCHAR( 128 )";
					    
						$res = execute_db($sql, $conn);
					}
				
		
				case '8.1-Lerici':
				
				    $sql = "ALTER TABLE ".$quote.$prefix_internal_table."forms".$quote." ADD chosen_ajax_field VARCHAR(1) NOT NULL DEFAULT '0'";
				    
				    $res = execute_db($sql, $conn);
				    
				
				case '8.2-Lerici':
				
					if (isset($_POST['register']) && (int)$_POST['register'] === 1){
				
						$sql = "SELECT id_installation, code_installation FROM ".$quote.$prefix_internal_table.'installation_tab'.$quote;
					
						$res = execute_db($sql, $conn);
					
						$row = fetch_row_db($res);
					
						$id_installation = $row['id_installation'];
						$code_installation = $row['code_installation'];
						
						$upgrade_process_result = @file_get_contents_2('https://dadabik.com/process_upgrade.php?id_installation='.$id_installation.'&code_installation='.urlencode($code_installation).'&dbms_type='.$dbms_type.'&dadabik_version='.urlencode($dadabik_version));
						
						if ($upgrade_process_result === false){
							echo '<p>There are problems with the Internet connection, the on-line registration is not possible......</p>';
						} // end if
						else{
							echo '<p>On-line registration done......</p>';
						} // end else
					}
				
					manage_other_infos_installation('update', 'upgrade_version',$dadabik_version.' '.$dadabik_edition);
					manage_other_infos_installation('update', 'upgrade_time',time());
					manage_other_infos_installation('update', 'upgrade_dbms',$dbms_type);
				
					echo "<p>......DaDaBIK correctly upgraded!! You can now <a href=\"index.php\">start using it</a>.</p>";
				
					$sql = "SELECT separator_field FROM ".$quote.$prefix_internal_table."forms".$quote;
						
					$res = execute_db($sql, $conn);
					$changed_separator = 0;
					while($row = fetch_row_db($res)){
						$separator_field = $row['separator_field'];
						if ($separator_field !== FORM_CONFIGURATOR_SEPARATOR){
							$changed_separator = 1;
							break;
						}
						
					}
					if ($changed_separator === 1){
						echo "<h2>Warning</h2><p>Until DaDaBIK 8, you had, for each form field in form configurator, the possibility to choose a custom separator (by default ~) that you could use for example to list several linked fields in the configuration of a form. Starting from DaDabK 8 there is just one separator (by default ~) that you can set in config.php (parameter FORM_CONFIGURATOR_SEPARATOR). It seems you have used, for one or more form fields, a separator different respect to the one you have in config.php: you can change the parameter in config.php or open the table ".$prefix_internal_table."forms with phpmyadmin or other similar tool and change each occurrence of the separator wiht the correspondant you have in config.php (the fields were the separator can be used are: items_table_fk_field_names_field, items_table_names_field, linked_fields_field, select_options_field; you can leave separator_field as it is since it is not used anymore).</p>";
					}
					
					
					
					
				
					break;
		}
		
		complete_trans_db();
	}
} // end if ($upgrade === 1)
}
else{

	if ($dbms_type === 'sqlite'){	
		echo '<p>Due to SQLite limitations, the upgrade is available just for MySQL and PostgreSQL.</p>';
	}
	else{

		$temp_ar = get_current_version(0);
		
		$temp_ar_2 = explode(',', $temp_ar);
		
		$current_version = $temp_ar_2[0];
		
		echo '<p>Your current DaDaBIK version is <b>'.$current_version.'</b>';
			
		if ($current_version <= '5.0'){
			echo '<p>Your current version is prior to 5.0, it is not possible to upgrade it using this procedure. You have to <a href="install.php">install</a> DaDaBIK from scratch.</p>';
		}
		else{
			
			if (false && $current_version === $dadabik_version){
				echo '<p>This procedure provides an upgrade to version '.$dadabik_version.' but the version installed is already '.$dadabik_version.', continue only if you are trying to upgrade from PRO to ENTERPRISE.</p>';
			}
			else{

				echo '<p>This upgrade procedure allows you to upgrade DaDaBIK to version <b>'.$dadabik_version.'</b></p>';
			}
			
			if ($current_version <= '7.1'){
				echo '<p>Please note that DaDaBIK 7.1 slightly changed the way custom formatting functions must be written (see comments in /include/custom_functions.php), please update your custom functions before upgrading if you are still using the old approach.</p>';
			}
		
			echo '<p>Please note that starting from DaDaBIK 8, users can change their own password without asking the administrators.</p>';
		
			echo '<p>Before proceeding, please <b>READ the "Upgrade from previous versions" section</b> in the documentation.</p>';
		
			echo '<p>The upgrade will not affect your DaDaBIK configuration and your data but, just in case, please create a backup of your database before upgrading.</p>';
		
			echo '<p>Please note that, if there are some locked records (DaDaBIK record locking feature), the records could be unlocked by this procedure before upgrading.</p>';
		
			echo '<p>Always read the change log (file changelog.htm) to check if any features/behaviours have changed respect to previous versions.</p>';
		
			echo '<form action="upgrade.php" method="post">';
			echo '<input type="hidden" name="upgrade" value="1">';

			echo "<input type=\"checkbox\" name=\"register\" value=\"1\" checked> Communicate this upgrade to dadabik.com<br>Just the DBMS type (e.g. MySQL) and the DaDaBIK version (e.g. 4.4) will be transmitted, NO PERSONAL INFORMATION. This is usefult to keep track of the DaDaBIK installation upgrades worldwide.<br><br>";
			echo '<input type="submit" value="Click this button AND WAIT to upgrade DaDaBIK">';
			echo '</form>';
			
		}
	}
} // end else


echo '</div>';

// include footer
include ("./include/footer_install.php");
?>
